c
c**********************************************************************************
c
CJH  *******************************************************************
C         PROFIL NOW PRODUCES CORRECTLY NORMALISED FUNCTIONS           *
C         THE FUNCTION RETURNS ALL RELEVANT DERIVATIVES,               *
C             DERIVATIVES BEING COMPLETE EXCEPT FOR A FACTOR PROFIL    *
C             WHICH IS INCORPORATED IN SUMMAT                          *
CJH  *******************************************************************
c
      FUNCTION PROFIL(N,DELTA)
      include 'param.inc'
      REAL ALPHA,BETA,DERALPHA,DERBETA,HG,HL,PI
      REAL ABCO,UCO,VCO,YCO, ZCO, SIG2, UC2,YC2,ZC2,VC2,UYCO,VZCO,ECO
      REAL PROFG,PROFL
      COMPLEX PCO,QCO,EXPPCO(1),EXPQCO(1)
      INTEGER IERR
      COMMON/PRFX/TANTH,TL,GAM,PASYM,DERHW,DERGAM,DERASY,DERZ,DERTTB
      COMMON/PRTOF/ALPHA,BETA,DERALPHA,DERBETA
      DATA ELIMIT/-89.416/,PLIMIT/1.0E-38/,YTEST/9.2692/
C      
      PI =  3.14159265359
      HW=TL
      GOTO(10,20,30,40,50,60,70,80),N
      STOP 'ILLEGAL PROFILE FUNCTION REQUEST'
c
C     PSEUDO-VOIGT                                                        !0.6005= 1/SQRT(4LN2)  = 1/SQRT(C1)  (EQ 4)
c
   10 TM=HW*0.600561205
      X=DELTA/TM
      CALL PVOIT(X,Y,U,V,DUDX,DVDY)                                       !X = [ (2THETAI - 2THETAK)/HK ] * SQRT(C1)
      PROFIL= ( GAM*0.636619772*V + (1.0-GAM)*.939437279*U) / HW          ! .9394 =  SQRT(C1/PI)
      DERHW= GAM*0.636619772*Y*DVDY + (1.0-GAM)*.939437279*X*DUDX
      DERHW= -1.0/HW - DERHW/(HW*HW*PROFIL)
      DERGAM= (0.636619772*V - 0.939437279*U) / HW
      DERGAM= DERGAM/PROFIL
      DERASY=0.0
      DERZ= GAM*1.273239545*DVDY + (1.0-GAM)*1.564265676*DUDX
      DERZ= -DERZ/(HW*HW*PROFIL)
      DERTTB=DERZ
      RETURN
c
C     PEARSON VII
C     DERGAM IS APPROXIMATE ONLY
c
   20 X=(DELTA/HW)**2
      PROFIL=2.*SQRT(2.**(1./GAM)-1.)*GAMMAF(GAM)
     1       /(SQRT(3.141592654)*GAMMAF(GAM-0.5))
     2       /(1.+4.*(2.**(1./GAM)-1.)*X)**GAM
      PROFIL=PROFIL/HW
      PRFDER=GAM*4.*(2.**(1/GAM)-1.)/(1.+4.*(2.**(1./GAM)-1.)*X)
      DERHW=(2.0*PRFDER*X - 1.0)/HW
      DERGAM=4.*2.**(1./GAM)*ALOG(2.)*X
     2     /(GAM*(1.+4.*(2.**(1./GAM)-1.)*X))
     3     -ALOG(1.+4.*(2.**(1./GAM)-1.)*X)
      DERASY=0.0
      DERZ=2.0*PRFDER*DELTA/HW**2
      DERTTB=DERZ
      RETURN
c
C     VOIGT
c
   30 TM=HW*0.600561205
c      SECTH=SQRT(1.+TANTH*TANTH)
      X=DELTA/TM
      Y=0.5*GAM/TM
      CALL WERF1(X,Y,U,DUDX,DUDY)
      PROFIL=0.939437279*U/HW
      DERHW=-0.338830376*(U+X*DUDX+Y*DUDY)/(TM**2*PROFIL)
      DERGAM=0.282094792*DUDY/(TM**2*PROFIL)
      DERASY=0.0
      DERZ=-0.564189584*DUDX/(TM**2*PROFIL)
      DERTTB=DERZ
      RETURN
c
C     SUM OF PSEUDO-VOIGTS (ASYMMETRIC)
c
   40 TM=HW*0.600561205
      COT2TH=0.5*(1.-TANTH*TANTH)/TANTH
      ASYM=PASYM*COT2TH
      X1=DELTA/TM
      CALL PVOIT(X1,Y1,U1,V1,DUDX1,DVDY1)
      X2=(DELTA+ASYM/16.0)/TM
      CALL PVOIT(X2,Y2,U2,V2,DUDX2,DVDY2)
      X3=(DELTA+ASYM/4.0)/TM
      CALL PVOIT(X3,Y3,U3,V3,DUDX3,DVDY3)
      X4=(DELTA+9.*ASYM/16.)/TM
      CALL PVOIT(X4,Y4,U4,V4,DUDX4,DVDY4)
      X5=(DELTA+ASYM)/TM
      CALL PVOIT(X5,Y5,U5,V5,DUDX5,DVDY5)
      PROFIL= (GAM*0.053051648*(V1+4.0*V2+2.0*V3+4.0*V4+V5)
     # + (1.0-GAM)*0.078286440*(U1+4.0*U2+2.0*U3+4.0*U4+U5)) /HW
      DERHW=   GAM*0.053051648*(Y1*DVDY1+4.0*Y2*DVDY2+2.0*Y3*DVDY3
     #            + 4.0*Y4*DVDY4 + Y5*DVDY5)
     # + (1.0-GAM)*0.078286440*(X1*DUDX1 + 4.0*X2*DUDX2 + 2.0*X3*DUDX3
     #            + 4.0*X4*DUDX4 + X5*DUDX5)
      DERHW= -1.0/HW - DERHW/(HW*HW*PROFIL)
      DERGAM=    (0.053051648*(V1+4.0*V2+2.0*V3+4.0*V4+V5)
     #          - 0.078286440*(U1+4.0*U2+2.0*U3+4.0*U4+U5))/(HW*PROFIL)
      DERASY=    GAM*0.026525824*(DVDY2+2.0*DVDY3+9.0*DVDY4+4.0*DVDY5)
     #   + (1.0-GAM)*0.032588868*(DUDX2+2.0*DUDX3+9.0*DUDX4+4.0*DUDX5)
      DERASY=DERASY*COT2TH/(HW*HW*PROFIL)
      DERZ=  GAM*0.106103295*(DVDY1+4.0*DVDY2+2.0*DVDY3+4.0*DVDY4+DVDY5)
     #+(1.0-GAM)*0.130355473*(DUDX1+4.0*DUDX2+2.0*DUDX3+4.0*DUDX4+DUDX5)
      DERZ= -DERZ/(HW*HW*PROFIL)
      DERTTB=DERZ - PASYM*DERASY*(1.0+COT2TH*COT2TH)/COT2TH
      RETURN
c
C     SUM OF VOIGTS (ASYMMETRIC)
c
   50 TM=HW*0.600561205
C      SECTH=SQRT(1.+TANTH*TANTH)
      COT2TH=0.5*(1.-TANTH*TANTH)/TANTH
      ASYM=PASYM*COT2TH
      Y=0.5*GAM/TM
      X1=DELTA/TM
      CALL WERF1(X1,Y,U1,DUDX1,DUDY1)
      X2=(DELTA+ASYM/16.0)/TM
      CALL WERF1(X2,Y,U2,DUDX2,DUDY2)
      X3=(DELTA+ASYM/4.0)/TM
      CALL WERF1(X3,Y,U3,DUDX3,DUDY3)
      X4=(DELTA+9.*ASYM/16.)/TM
      CALL WERF1(X4,Y,U4,DUDX4,DUDY4)
      X5=(DELTA+ASYM)/TM
      CALL WERF1(X5,Y,U5,DUDX5,DUDY5)
      PROFIL=0.078286440*(U1+4.0*U2+2.0*U3+4.0*U4+U5)/HW
      DERHW=-0.078286440*(X1*DUDX1+Y*DUDY1+4.0*(X2*DUDX2+Y*DUDY2)
     #     +2.0*(X3*DUDX3+Y*DUDY3)+4.0*(X4*DUDX4+Y*DUDY4)
     #     +X5*DUDX5+Y*DUDY5)/(HW**2*PROFIL)  - 1.0/HW
      DERGAM=0.065177737*(DUDY1+4.0*DUDY2+2.0*DUDY3+4.0*DUDY4+DUDY5)
     #          /(HW**2*PROFIL)
      DERASY=0.032588868*(DUDX2+2.0*DUDX3+9.0*DUDX4+4.0*DUDX5)*COT2TH
     #          /(HW**2*PROFIL)
      DERZ=-0.130355473*(DUDX1+4.0*DUDX2+2.0*DUDX3+4.0*DUDX4+DUDX5)
     #        /(HW**2*PROFIL)
      DERTTB=DERZ - PASYM*DERASY*(1.0+COT2TH*COT2TH)/COT2TH
      RETURN                     
   60 CONTINUE
c
c		Split Pearson
c
      STOP 'CW: SPLIT PEARSON NOT IMPLEMENTED YET'
      RETURN
c
C         JORGENSEN PEAK SHAPE      
C     NOTE: THE PEAK CENTRE IS DEFINED AS THE APEX OF THE TWO DECAYING EXPONENTIALS - NOT 
C           AT THE FIRST MOMENT (WHICH EQUALS ALPHA-BETA) AS ONE WOULD EXPECT 
C           (NO REASON FOR THIS CAN BE FOUND?)

   70 CONTINUE
      DERGAM = 0.0
      DERASY = 0.0
      SIG2 = HW*HW
      HG = ABS(HW)*2.354820045031											!2,35482 = SQRT(8*LN(2))
      HL = GAM
      HMIX = PVMIX(HG,HL)
C		GAUSSIAN CONTRIBUTION
      ABCO = ALPHA*BETA/(2.0*(ALPHA+BETA))
      UCO  = 0.5*ALPHA*(ALPHA*SIG2 + 2.0*DELTA)
      VCO  = 0.5*BETA*(BETA*SIG2   - 2.0*DELTA)
      YCO  = (ALPHA*SIG2 + DELTA)/(SQRT(2.0*SIG2))
      ZCO  = (BETA*SIG2  - DELTA)/(SQRT(2.0*SIG2))
      IF (YCO.LE.YTEST) THEN
         UC2 = EXP(UCO)
         YC2 = ERFCC(YCO)
         UYCO = UC2*YC2
         IF(UYCO.LT.PLIMIT) UYCO = 0.0
      ELSE         
          UYCO = 0.0
          UC2 = 0.0
          YC2 = 0.0
      ENDIF     
      IF (ZCO.LE.YTEST) THEN
         VC2 = EXP(VCO)
         ZC2 = ERFCC(ZCO)
         VZCO = VC2*ZC2
         IF(VZCO.LT.PLIMIT) VZCO = 0.0
      ELSE
          VC2 = 0.0
          ZC2 = 0.0
          VZCO = 0.0
      ENDIF                             
      ECO = -DELTA*DELTA/(2.0*SIG2)
      IF (ECO.GE.ELIMIT) THEN
          ECO = EXP(ECO)
      ELSE
          ECO = 0.0
      ENDIF
C       LORENTZIAN CONTRIBUTION
      PCO = CMPLX(-ALPHA*DELTA, ALPHA*HL*0.5)
      QCO = CMPLX(-BETA*DELTA, BETA*HL*0.5)
      CALL CEXINT(PCO,1,2,0.000001,1,EXPPCO,IERR)
      IF (IERR.NE.0) THEN EXPPCO=CMPLX(0,0)
C	WRITE(*,*) EXPPCO
      CALL CEXINT(QCO,1,2,0.000001,1,EXPQCO,IERR)
      IF (IERR.NE.0) THEN EXPQCO=CMPLX(0,0)
C	WRITE(*,*) EXPQCO
C
C
      PROFG = ABCO*(UYCO + VZCO)
      PROFL = 2.0*ABCO/PI*(-AIMAG(EXPPCO(1))-AIMAG(EXPQCO(1))) 
 
      PROFIL = PROFG*(1-HMIX) + PROFL*HMIX 

      DERHW = ABCO*( ALPHA*ALPHA*HW*UYCO + BETA*BETA*HW*VZCO -
     *  0.7978845608029*ECO*(ALPHA+BETA))                                              !0.7978 = SQRT(2/PI)
      DERZ=ABCO*(ALPHA*UYCO-BETA*VZCO)
      IF (PROFIL.NE.0) THEN                                                            !catches errors
          DERHW = DERHW/PROFIL
          DERZ =  DERZ/PROFIL
          DERALPHA = (1-HMIX)*(BETA/(ALPHA*(ALPHA+BETA)) - 
     *        0.7978845608029*ABCO*ECO*HW/PROFIL + 
     *        ABCO*UC2*(DELTA + ALPHA*SIG2)*YC2/PROFIL)
          DERBETA = (ALPHA/(BETA*(ALPHA+BETA)) -
     *        0.7978845608029*ABCO*ECO*HW/PROFIL + 
     *        ABCO*VC2*(-DELTA + BETA*SIG2)*ZC2/PROFIL)
      ELSE
          DERHW = 0.0
          DERZ = 0.0
          DERALPHA = 0.0
          DERBETA = 0.0
      ENDIF
      DERTTB = DERZ
      RETURN
c
C         IKEA-CARPENTER PEAK SHAPE
c
   80 CONTINUE
      STOP 'TOF: IKEA-CARPENTER PEAK NOT IMPLEMENTED YET'
      RETURN
      END
c
c**********************************************************************************
c
c
      SUBROUTINE PVOIT(X,Y,U,V,DUDX,DVDY)
      Y=1.201122409*X                                                                     !1.201122 = 
      U=EXP(-X*X)
      DUDX=-2.0*X*U
      V=1.0/(1.0+Y*Y)
      DVDY=-2.0*Y*V*V
      RETURN
      END
c
c**********************************************************************************
c
c
      SUBROUTINE WERF1(X,Y,U,DUDX,DUDY)
      CALL FC01A(X,Y,U,V)
      IF (U.LT.1.0E-05) U=1.0E-05
      DUDX=-2.0*X*U + 2.0*Y*V
      DUDY=-1.128379167 + 2.0*X*V + 2.0*Y*U
      RETURN
      END
c
c**********************************************************************************
c
c
      SUBROUTINE FC01A(SSXSI,SSETA,SSU,SSV)                                     
C     FROM HARWELL SUBROUTINE LIBRARY - SEE REPORT AERE-R9185
      IMPLICIT REAL*8(A-H,O-Z)
      REAL * 4 SSXSI,SSETA,SSU,SSV
      DIMENSION S(41),T(41),C(30),D(30)                                         
      XSI=SSXSI                                                                 
      ETA=SSETA                                                                 
      IENT=1                                                                    
      GO TO 77                                                                  
      ENTRY FC01AD(DXSI,DETA,DU,DV)                                             
      IENT=2                                                                    
      XSI=DXSI                                                                  
      ETA=DETA                                                                  
   77 CONTINUE                                                                  
      PI=3.1415926535898D0                                                      
      PJ=2.0D0/DSQRT(PI)                                                        
      X=DABS(XSI)                                                                
      Y=DABS(ETA)                                                                
      Z=DSQRT(X*X+Y*Y)                                                           
      IF(Z-0.9D0)1,2,2                                                          
    1 ASSIGN 100 TO I1                                                          
      GO TO 30                                                                  
    2 IF(Z-1.1D0)3,3,6                                                          
    3 ASSIGN 4 TO I1                                                            
      GO TO 30                                                                  
    4 U1 = U                                                                    
      V1 = V                                                                    
      ASSIGN 5 TO I1                                                            
      GO TO 40                                                                   
    5 U2 = U                                                                     
      V2 = V                                                                    
      U=5.0D0*((Z-0.9D0)*U2+(1.1D0-Z)*U1)                                       
       V=5.0D0*((Z-0.9D0)*V2+(1.1D0-Z)*V1)                                      
      GO TO 100                                                                 
    6 IF(Z-3.9D0)7,120,120                                                      
    7 ASSIGN 99 TO I1                                                           
      ASSIGN 100 TO I2                                                          
    8 IF(Y-1.3D0)40,9,9                                                         
    9 IF(Y-1.5D0)10,10,13                                                       
   10 ASSIGN 11 TO I1                                                           
      GO TO 40                                                                  
   11 U1 = U                                                                    
      V1 = V                                                                    
      ASSIGN 12 TO I1                                                           
       H=0.3D0                                                                  
      GO TO 54                                                                  
   12 U2 = U                                                                    
      V2 = V                                                                    
      U=5.0D0*((Y-1.3D0)*U2+(1.5D0-Y)*U1)                                       
      V=5.0D0*((Y-1.3D0)*V2+(1.5D0-Y)*V1)                                       
      GO TO 99                                                                  
   13 IF(Y-1.8D0)14,15,15                                                       
   14 H=0.3D0                                                                   
      GO TO 54                                                                  
   15 IF(Y-2.0D0)16,16,101                                                      
   16 ASSIGN 17 TO I1                                                           
      H=0.3D0                                                                   
      GO TO 54                                                                  
   17 ASSIGN 18 TO I1                                                           
      U1 = U                                                                    
      V1 = V                                                                    
        H=0.4D0                                                                 
      GO TO 54                                                                  
   18 U2 = U                                                                     
      V2 = V                                                                    
      U=5.0D0*((Y-1.8D0)*U2+(2.0D0-Y)*U1)                                        
        V=5.0D0*((Y-1.8D0)*V2+(2.0D0-Y)*V1)                                     
      GO TO 99                                                                  
  101 IF(Y-2.5D0)102,103,103                                                    
  102 ASSIGN 99 TO I1                                                           
      H=0.4D0                                                                   
      GO TO 54                                                                  
  103 IF(Y-2.7D0)104,104,107                                                    
  104 ASSIGN 105 TO I1                                                           
      H=0.4D0                                                                    
      GO TO 54                                                                  
  105 U1 = U                                                                    
      V1 = V                                                                    
      ASSIGN 106 TO I1                                                          
      H=0.5D0                                                                   
      GO TO 54                                                                  
  106 U2 = U                                                                    
      V2 = V                                                                    
      U=5.0D0*((Y-2.5D0)*U2+(2.7D0-Y)*U1)                                       
      V=5.0D0*((Y-2.5D0)*V2+(2.7D0-Y)*V1)                                       
      GO TO 99                                                                  
  107 IF(Y-3.75D0)108,109,109                                                   
  108 ASSIGN 99 TO I1                                                           
      H=0.5D0                                                                   
      GO TO 54                                                                  
  109 IF(Y-3.85D0)112,113,113                                                   
  112 ASSIGN 110 TO I1                                                           
      H=0.5D0                                                                   
      GO TO 54                                                                  
  110 U1 = U                                                                    
      V1 = V                                                                    
      ASSIGN 111 TO I1                                                          
      H=0.6D0                                                                   
      GO TO 54                                                                  
  111 U2 = U                                                                    
      V2 = V                                                               
      U=10.0D0*((Y-3.75D0)*U2+(3.85D0-Y)*U1)                               
      V=10.0D0*((Y-3.75D0)*V2+(3.85D0-Y)*V1)                                 
      GO TO 99                                                              
  113 ASSIGN 99 TO I1                                                       
      H=0.6D0                                                                
      GO TO 54                                                           
  120 IF(Z-4.1D0)121,121,123                                               
  121 ASSIGN 99 TO  I1                                                  
      ASSIGN 122 TO I2                                                    
      GO TO 8                                                              
  122 U1 = U                                                               
      V1 = V                                                                 
      ASSIGN 130 TO I2                                                     
      GO TO 125                                                            
  123 IF(Z-5.8D0)124,124,131                                               
  124 ASSIGN 99 TO I1                                                       
      ASSIGN 100 TO I2                                                      
  125 A2=2.0D0*X*Y                                                       
      A6 = X*X+Y*Y                                                            
      GO TO 64                                                              
  130 U2 = U                                                                  
      V2 = V                                                                  
      U=5.0D0*((4.1D0-Z)*U1+(Z-3.9D0)*U2)                                     
      V=5.0D0*((4.1D0-Z)*V1+(Z-3.9D0)*V2)                                    
      GO TO 100                                                              
  131 IF(Z-6.2D0)134,134,132                                                
  132 ASSIGN 100 TO I2                                                      
  133 A2=2.0D0*X*Y                                                           
      A6 = X*X+Y*Y                                                           
      ASSIGN 99 TO I1                                                      
      GO TO 61                                                               
  134 ASSIGN 135 TO I2                                                       
      GO TO 133                                                              
  135 U1 = U                                                                
      V1 = V                                                                
      ASSIGN 136 TO I2                                                     
      GO TO 125                                                             
  136 U2 = U                                                                 
      V2 = V                                                                  
      U=2.5D0*((Z-5.8D0)*U1+(6.2D0-Z)*U2)                                     
      V=2.5D0*((Z-5.8D0)*V1+(6.2D0-Z)*V2)                                    
      GO TO 100                                                           
   30 S(1)=X                                                                 
      T(1)=Y                                                                 
      S(2)=X*X-Y*Y                                                         
      T(2)=2.0D0*X*Y                                                        
      E1=DEXP(-S(2))                                                        
      E2=DCOS(T(2))                                                          
      E3=DSIN(T(2))                                                          
      J=1                                                                  
      U=1.0D0-PJ*T(1)                                                       
      V=PJ*S(1)                                                               
      E4=E1*(E2*U+E3*V)                                                    
      V=E1*(E2*V-E3*U)                                                       
      U=E4                                                                 
      DO 33 I=3,41,2                                                        
      S(I)=(S(I-2)*S(2)-T(I-2)*T(2))/J                                      
      T(I)=(S(I-2)*T(2)+T(I-2)*S(2))/J                                        
      J=J+1                                                                   
      UE=-PJ*T(I)/I                                                         
      VE=PJ*S(I)/I                                                        
      E5=E1*(E2*UE+E3*VE)                                                
      VE=E1*(E2*VE-E3*UE)                                                   
      UE=E5                                                                 
      IF(DABS(UE)-.1D-6)31,31,32                                              
   31 IF(DABS(VE)-.1D-6)34,34,32                                              
   32 U=U+UE                                                               
      V=V+VE                                                            
   33 CONTINUE                                                          
   34 GO TO 80                                                              
   40 S(1)=0.46752093659378D0                                               
      T(1)=0.17912253437764D0                                                 
      S(2)=0.20798989547526D0                                             
      T(2)=0.29084679383680D0                                               
      S(3)=0.07508765293733D0                                                
      T(3)=0.21954582524901D0                                              
      S(4)=0.03526344064839D0                                              
      T(4)=0.16054790355559D0                                                
      I=AMIN0(3,IDINT(X))                                                   
      A=I+0.5                                                                 
      B=0.7D0                                                              
      C(1)=S(I+1)                                                         
      D(1)=T(I+1)                                                           
      C(2)=-2.0D0*A*C(1)+2.0D0*B*D(1)                                       
      D(2)=-2.0D0*A*D(1)-2.0D0*B*C(1)+PJ                                  
      F=X-A                                                                
      G=Y-B                                                                 
      U=C(1)+C(2)*F-D(2)*G                                                  
      V=D(1)+C(2)*G+D(2)*F                                                  
      FA=F*F-G*G                                                            
      GA=2.0D0*F*G                                                          
      DO 43 I=3,30                                                         
      C(I)=(-2.0D0*A*C(I-1)+2.0D0*B*D(I-1)-2.0D0*C(I-2))/(I-1)               
      D(I)=(-2.0D0*A*D(I-1)-2.0D0*B*C(I-1)-2.0D0*D(I-2))/(I-1)            
      UB=C(I)*FA-D(I)*GA                                                 
      VB=C(I)*GA+D(I)*FA                                                     
      FB=FA*F-GA*G                                                       
      GA=FA*G+GA*F                                                         
      FA=FB                                                                
      IF(DABS(UB)-.1D-6)41,41,42                                            
   41 IF(DABS(VB)-.1D-6)44,44,42                                            
   42 U=U+UB                                                                
      V=V+VB                                                               
   43 CONTINUE                                                             
   44 GO TO 80                                                              
   54 E2=DEXP(H*H)                                                           
      E3=1.0D0/(E2*E2)                                                       
      A1=PI*(X*X+Y*Y)                                                        
      U=Y*H/A1                                                                
      V=X*H/A1                                                               
      E1=1.0D0                                                              
      W=0.0D0                                                               
      DO 56 L=1,50                                                           
      W=W+H                                                               
      E1=E1*E2*E3**L                                                     
      A1=X-W                                                                
      A2=X+W                                                             
      A3=(A1*A1+Y*Y)*PI                                                      
      A4=(A2*A2+Y*Y)*PI                                                      
      A5=H*E1*Y*(1.0D0/A3+1.0D0/A4)                                           
      A6=H*E1*(A1/A3+A2/A4)                                                  
      U=U+A5                                                                
      V=V+A6                                                                 
      IF(DABS(A5)-.1D-6)55,55,56                                             
   55 IF(DABS(A6)-.1D-6)57,57,56                                          
   56 CONTINUE                                                             
   57 GO TO 80                                                            
   61 ALP1=0.01995324205905D0/PI                                      
      X1=2.020182870456086D0                                            
      I=1                                                                
      GO TO 72                                                          
   62 U=UA                                                               
      V=VA                                                             
      ALP1=0.3936193231522D0/PI                                             
      X1=0.958572464613819D0                                            
      I=2                                                               
      GO TO 72                                                               
   63 ALP2=0.9453087204829D0/PI                                               
      U=U+UA+Y*ALP2/A6                                                        
      V=V+VA+X*ALP2/A6                                                   
      GO TO 80                                                            
   64 ALP1=.7640432855233D-5/PI                                           
      X1=3.436159118837738D0                                             
      I=3                                                                
      GO TO 72                                                               
   65 U=UA                                                                  
      V=VA                                                                
      X1=2.532731674232790D0                                             
      ALP1=.1343645746781D-2/PI                                             
      I=4                                                                 
      GO TO 72                                                             
   66 U=U+UA                                                                        
      V=V+VA                                                              
      ALP1=.3387439445548D-1/PI                                            
      X1=1.756683649299882D0                                                 
      I=5                                                                   
      GO TO 72                                                              
   67 U=U+UA                                                                
      V=V+VA                                                             
      ALP1=0.2401386110823D0/PI                                             
      X1=1.036610829789514D0                                               
      I=6                                                                  
      GO TO 72                                                             
   68 U=U+UA                                                               
      V=V+VA                                                            
      ALP1=0.6108626337353D0/PI                                            
      X1=0.342901327223705D0                                                
      I=7                                                                   
      GO TO 72                                                            
   69 U=U+UA                                                                  
      V=V+VA                                                                  
      GO TO 80                                                             
   72 A1=X*X-Y*Y-X1*X1                                                    
      A3=A1*A1+A2*A2                                                         
      A4=X*A2-Y*A1                                                          
      A5=X*A1+Y*A2                                                        
      UA=2.0D0*ALP1*A4/A3                                                  
      VA=2.0D0*ALP1*A5/A3                                                  
      GO TO (62,63,65,66,67,68,69),I                                      
   80 IF(X-XSI)84,81,84                                                      
   81 IF(Y-ETA)82,90,82                                                      
   82 E1=DEXP(Y*Y-X*X)                                                    
      E2=2.0D0*X*Y                                                         
      E3=DCOS(E2)                                                        
      U=-U+2.0D0*E1*E3                                                   
      E3=DSIN(E2)                                                        
      V=-V-2.0D0*E1*E3                                                   
      IF(X-XSI)90,83,90                                                  
   83 V=-V                                                              
      GO TO 90                                                          
   84 IF(Y-ETA)82,83,82                                                    
   90 GO TO I1,(4,5,11,12,17,18,99,100,105,106,110,111)                     
   99 GOTO I2,(100,122,130,135,136)                                         
  100 IF(IENT.NE.1)GO TO 220                                                
      SSU=U                                                            
      SSV=V                                                              
      GO TO 222
  220 DU=U
      DV=V
  222 RETURN                                                          
      END                                                            
c
c**********************************************************************************
c
C
C      COMPUTES THE GAMMA FUNCTION
C
      FUNCTION GAMMAF(XX)
      IF (XX-57.) 6,6,4
    4 IER=2
      GAMMAF=100.0
      RETURN
    6 X=XX
      ERR=1.0E-6
      GAMMAF=1.0
      IF (X-2.0) 50,50,15
   10 IF (X-2.0) 110,110,15
   15 X=X-1.0
      GAMMAF=GAMMAF*X
      GO TO 10
   50 IF (X-1.0) 60,120,110
   60 IF (X-ERR) 62,62,80
   62 Y=FLOAT(INT(X))-X
      IF (ABS(Y)-ERR) 130,130,64
   64 IF (1.0-Y-ERR) 130,130,70
   70 IF (X-1.0) 80,80,110
   80 GAMMAF=GAMMAF/X
      X=X+1.0
      GO TO 70
  110 Y=X-1.0
      GY=1.0+Y*(-0.5771017+Y*(+0.9858540+Y*(-0.8764218+Y*(+0.8328212+
     *Y*(-0.5684729+Y*(+0.2548205+Y*(-0.05149930)))))))
      GAMMAF=GAMMAF*GY
  120 RETURN
  130 IER=1
      GAMMAF=ERR
      RETURN
      END
c
c**********************************************************************************
c
C
c      VHALF IS AN APPROXIMATE VALUE FOR THE FWHM
      FUNCTION VHALF(K,TT,H1,H2,H3,JDS,NP)                                    !TT = TAN(THETA) or dvalue
      include 'param.inc'
      INTEGER JDS,J,H1,H2,H3
      REAL AHKL(3),HKL(3),AAN,HG1,TANG
      LOGICAL HKLZERO
      COMMON/PARAMS/GLB(MAXGP),AGLB(MAXGP),LGLB(MAXGP),PAR(NUPH,MAXAP),
     *APAR(NUPH,MAXAP),LPAR(NUPH,MAXAP),XL(NATS,14),LP(NATS,14),
     *A(NATS,14),PTR(MAXDS,NATS),RELAX(4),RATIO(MAXDS,2),IPTYPE(NUPH)
      COMMON/ANISO/ ANHKL(MAXDS,NUPH,3),IAP(MAXDS) 
      J = (JDS-1)*MAXIPAR            
      HKLZERO = (H1.EQ.0.AND.H2.EQ.0.AND.H3.EQ.0).OR.(IAP(JDS).EQ.0)
      IF (.NOT.HKLZERO) THEN
          HKL(1)  = FLOAT(H1)
          HKL(2)  = FLOAT(H2)
          HKL(3)  = FLOAT(H3)
          HSUM = 0.0
          DO 10 I=1,3
   10         AHKL(I) = ANHKL(JDS,K,I)
          TANG = 1
      ELSE
          AAN = 0.0
          TANG = 0.0
      ENDIF        
      HG = GAUSPEAK(NP,TT,PAR(K,3+J),PAR(K,4+J),PAR(K,5+J),PAR(K,19+J),
     *             TANG)
      HG1 = 0.0
      IF (NP.EQ.7) HG1 =1.0/(PAR(K,21+J)+PAR(K,22+J)/TT) +
     &                  1.0/(PAR(K,23+J)+PAR(K,24+J)/TT**4)                       !ADDITION FOR EXPONENTIALS
C
      AA=1.895
      BB=1.995
      IF(NP.EQ.3.OR.NP.EQ.5) THEN
          HL=GAMMPEAK(NP,TT,PAR(K,15+J),PAR(K,16+J),PAR(K,17+J),TANG)
          VHALF= (HL*HL + AA*HL*HG + BB*HG*HG) / (HL+BB*HG)
      ELSE
          VHALF = HG + HG1
      ENDIF
      RETURN
      END
c
c**********************************************************************************
c
c              simple erfc calculation with errors less than 1.2E-7
      REAL FUNCTION ERFCC(X)
      Z=ABS(X)      
      T=1.0/(1.+0.5*Z)
      ERFCC=T*EXP(-Z*Z-1.26551223+T*(1.00002368+T*(.37409196+
     *    T*(.09678418+T*(-.18628806+T*(.27886807+T*(-1.13520398+
     *    T*(1.48851587+T*(-.82215223+T*.17087277)))))))))
      IF (X.LT.0.) ERFCC=2.-ERFCC
      RETURN
      END
c
c**********************************************************************************
c
C      
C        half width of psedudo voigt given hw of gaussian and lorentzian
      REAL FUNCTION PVHALF(HG,HL)
      PVHALF = (HG**5 + 2.69269*HG**4*HL + 2.42843*HG**3*HL**2 +
     * 4.47163*HG**2*HL**3+ 0.07842*HG*HL**4 + HL**5)**0.2
      RETURN
      END
c
c**********************************************************************************
c
C        pseudo-voigt mixing parameter, n
      REAL FUNCTION PVMIX(HG,HL)
      REAL HW
      HW = HL/PVHALF(HG,HL)
      PVMIX = 1.36603*HW + (-0.47719 + 0.11116*HW)*HW*HW
      RETURN
      END
c
c**********************************************************************************
c
C
C         Calculated the Gamma value
C
      FUNCTION GAMMPEAK(PTYPE,TT,G0,G1,G2,ANN)
      INTEGER PTYPE
      REAL TT,G0,G1,G2,GAM,ANN,ANGLE,PIC
      PIC= 114.5915590262
      GAM = 0.0
      IF (PTYPE.LE.5) ANGLE = ATAN(TT)*PIC
      IF ((PTYPE.EQ.1).OR.(PTYPE.EQ.4)) THEN
          GAM=G0+(G1 + G2*ANGLE)*ANGLE                                       !PSEUDO-VOIGT
      ENDIF
      IF (PTYPE.EQ.2) THEN
          GAM = G0+(G1 + G2*ANGLE)*ANGLE                                     !PEARSON
          IF (GAM.LT.0.6) GAM = 0.6
      ENDIF
      IF ((PTYPE.EQ.3).OR.(PTYPE.EQ.5)) THEN
          GAM=(G0+G2*ANN)*SQRT(1+TT*TT) + G1*TT                              !VOIGT    
      ENDIF
      GAMMPEAK = GAM
      RETURN
      END
C
C         Calculates the Gaussian FHWM         
C
      FUNCTION GAUSPEAK(PTYPE,TT,U,V,W,UAN,ANN)                        !TT = TAN(THETA)
      INCLUDE 'param.inc'
      INTEGER PTYPE
      REAL U,V,W,UAN,ANN,TT,GAUS
      GAUS = 0.0
      IF (PTYPE.LE.5) GAUS = ((U + UAN*ANN)*TT + V)*TT + W
      IF (PTYPE.EQ.7) GAUS = U + (V+UAN*ANN + W*TT*TT)*TT*TT
      IF ((GAUS.LE.0.0).AND.(GMIN.GT.0)) GAUS = GMIN
      GAUSPEAK = SQRT(GAUS)
      RETURN
      END                                 
c
c
c
C     FUNCTION DERGAUSS(NUM,TOF,TT,ANN)
C     LOGICAL TOF
C     INTEGER NUM
C     REAL TT,ANN,X,DX
C     IF (.NOT.TOF) THEN
C         X=TT*TT                                                     !FOR (U*TAN^2 + V*TAN + W)^0.5
C         DX = 1/TT
C     ELSE          
C         X = 1.0                                                     !FOR (SIG0 + SIG1*D^2 + SIG2*D^4)^0.5
C         DX = TT*TT 
C         ANN=(1-ANN)**2
C     ENDIF
C     IF (NUM.EQ.1) DER = X
C     IF (NUM.EQ.2) DER = X*DX
C     IF (NUM.EQ.3) DER = X*DX*DX
C     IF (NUM.EQ.4) DER = TT*TT*ANN
C     DERGAUSS = DER
C     RETURN
C     END

      SUBROUTINE CEXINT(Z, N, KODE, TOL, M, CY, IERR)
C***BEGIN PROLOGUE  CEXINT
C***DATE WRITTEN   870515   (YYMMDD)
C***REVISION DATE  870515   (YYMMDD)
C***CATEGORY NO.  B5E
C***KEYWORDS  EXPONENTIAL INTEGRALS, SINE INTEGRAL, COSINE INTEGRAL
C***AUTHOR  AMOS, DONALD E., SANDIA NATIONAL LABORATORIES
C***PURPOSE  TO COMPUTE EXPONENTIAL INTEGRALS OF A COMPLEX ARGUMENT
C***DESCRIPTION
C
C         ON KODE=1, CEXINT COMPUTES AN M MEMBER SEQUENCE OF COMPLEX
C         EXPONENTIAL INTEGRALS CY(J)=E(N+J-1,Z), J=1,...,M, FOR
C         POSITIVE ORDERS N,...,N+M-1 AND COMPLEX Z IN THE CUT PLANE
C         -PI.LT.ARG(Z).LE.PI (N=1 AND Z=CMPLX(0.0,0.0) CANNOT HOLD AT
C         THE SAME TIME). ON KODE=2, CEXINT COMPUTES SCALED FUNCTIONS
C
C                          CY(J)=E(N+J-1,Z)*CEXP(Z),      J=1,...,M,
C
C         WHICH REMOVES THE EXPONENTIAL BEHAVIOR IN BOTH THE LEFT AND
C         RIGHT HALF PLANES. DEFINITIONS AND NOTATION ARE FOUND IN THE
C         NBS HANDBOOK OF MATHEMATICAL FUNCTIONS (REF. 1).
C
C         INPUT
C           Z      - Z=CMPLX(X,Y), -PI.LT.ARG(Z).LE.PI
C           N      - INTEGER ORDER OF INITIAL E FUNCTION, N=1,2,...
C                    (N=1 AND Z=CMPLX(0.0,0.0) IS AN ERROR)
C           KODE   - A PARAMETER TO INDICATE THE SCALING OPTION
C                    KODE= 1  RETURNS
C                             CY(J)=E(N+J-1,Z),          J=1,...,M
C                        = 2  RETURNS
C                             CY(J)=E(N+J-1,Z)*CEXP(Z),  J=1,...,M
C           TOL    - PRECISION (ACCURACY) DESIRED FOR THE SEQUENCE,
C                    URND.LE.TOL.LE.1.0E-3, WHERE URND IS LIMITED BY
C                    URND=AMAX1(UNIT ROUNDOFF,1.0E-18) AND UNIT
C                    ROUNDOFF = R1MACH(4) IN TERMS OF MACHINE CONSTANT
C                    ROUTINE R1MACH
C           M      - NUMBER OF E FUNCTIONS IN THE SEQUENCE, M.GE.1
C
C         OUTPUT
C           CY     - A COMPLEX VECTOR WHOSE FIRST M COMPONENTS CONTAIN
C                    VALUES FOR THE SEQUENCE
C                    CY(J)=E(N+J-1,Z)  OR
C                    CY(J)=E(N+J-1,Z)*CEXP(Z), J=1,...,M
C                    DEPENDING ON KODE.
C           IERR   - ERROR FLAG
C                    IERR=0, NORMAL RETURN - COMPUTATION COMPLETED
C                    IERR=1, INPUT ERROR   - NO COMPUTATION
C                    IERR=2, UNDERFLOW     - FIRST M COMPONENTS OF CY
C                            SET TO ZERO, CY(J)=CMPLX(0.0,0.0), J=1,M,
C                            REAL(Z).GT.0.0 TOO LARGE ON KODE=1
C                    IERR=3, OVERFLOW      - NO COMPUTATION,
C                            REAL(Z).LT.0.0 TOO SMALL ON KODE=1
C                    IERR=4, CABS(Z) OR N+M-1 LARGE - COMPUTATION DONE
C                            BUT LOSSES OF SIGNIFICANCE BY ARGUMENT
C                            REDUCTION PRODUCE LESS THAN HALF OF MACHINE
C                            ACCURACY
C                    IERR=5, CABS(Z) OR N+M-1 TOO LARGE - NO COMPUTA-
C                            TION BECAUSE OF COMPLETE LOSSES OF SIGNIFI-
C                            CANCE BY ARGUMENT REDUCTION
C                    IERR=6, ERROR         - NO COMPUTATION,
C                            ALGORITHM TERMINATION CONDITION NOT MET.
C                            SEE LONG DESCRIPTION ABOUT PARAMETER ICMAX.
C                    IERR=7, ERROR         - NO COMPUTATION,
C                            DISCRIMINATION ERROR. THIS CONDITION SHOULD
C                            NEVER OCCUR.
C
C***LONG DESCRIPTION
C
C         CEXINT USES A COMBINATION OF POWER SERIES AND BACKWARD RECUR-
C         RENCE DESCRIBED IN REF. 2 FOR THE COMPLEX Z PLANE EXCEPT FOR
C         A STRIP 2*YB WIDE ABOUT THE NEGATIVE REAL AXIS, WHERE ANALYTIC
C         CONTINUATION IS CARRIED OUT BY LIMITED USE OF TAYLOR SERIES.
C         THE SWITCH FROM BACKWARD RECURRENCE TO TAYLOR SERIES IS
C         NECESSARY BECAUSE BACKWARD RECURRENCE IS SLOWLY CONVERGENT
C         NEAR THE NEGATIVE REAL AXIS. THE BOUNDARIES Y=-YB AND
C         Y=YB WERE DETERMINED SO THAT BACKWARD RECURRENCE WOULD CON-
C         VERGE EASILY WITH N AS LARGE AS 100 AND TOL AS SMALL AS
C         1.0E-18. SUBROUTINE CEXENZ DOES THE BACKWARD RECURRENCE AND
C         SUBROUTINE CACEXI DOES THE ANALYTIC CONTINUATION. TO START THE
C         CONTINUATION, CACEXI CALLS CEXENZ WITH ZB=CMPLX(X,YB).
C         IF CEXENZ RETURNS IERR=6, THEN YB IS INCREASED BY 0.5 UNTIL
C         CEXENZ RETURNS IERR=0 OR 10 TRIES, WHICHEVER COMES FIRST.
C         WHEN IERR=0, THEN THE ANALYTIC CONTINUATION PROCEEDS VERTI-
C         CALLY DOWN FROM ZB=CMPLX(X,YB) TO Z=CMPLX(X,Y), 0.LE.Y.LT.YB.
C         CONJUGATION IS USED FOR Y.LT.0. YB INCREASES AS TOL DECREASES
C         TO KEEP CONVERGENCE RATES UP AND RECURRENCE DOWN.
C
C         PARAMETER ICDIM=250 ALLOCATES STORAGE FOR THE COEFFICIENTS OF
C         THE BACKWARD RECURRENCE ALGORITHM. IF THE ALGORITHM TERMINA-
C         TION CONDITION IS NOT MET IN ICDIM STEPS, THEN RECURRENCE PRO-
C         CEEDS WITH NO ADDITIONAL STORAGE UNTIL THE TERMINATION CONDI-
C         TION IS MET OR THE LIMIT ICMAX=2000 IS EXCEEDED. THE PURPOSE
C         OF STORAGE IS TO MAKE THE ALGORITHM MORE EFFICIENT. THE TERMI-
C         NATION CONDITION IS MET IN LESS THAN 250 STEPS OVER MOST OF
C         THE COMPLEX PLANE EXCLUDING THE STRIP ABS(Y).LT.YB, X.LT.0.
C         EXCEPTIONS TO THIS RULE ARE GENERATED NEAR STRIP BOUNDARIES
C         WHEN N+M-1 AND CABS(Z) ARE LARGE AND NEARLY EQUAL. IN THESE
C         CASES, THE CONVERGENCE IS VERY SLOW AND ADDITIONAL RECURRENCE
C         (UP TO ICMAX) MUST BE USED. ON THE OTHERHAND, THESE REGIONS
C         OF SLOW CONVERGENCE ARE KEPT SMALL BY ADJUSTING YB AS A FUNC-
C         TION OF TOL. THESE REGIONS COULD BE ELIMINATED ENTIRELY BY
C         MAKING YB SUFFICIENTLY LARGE, BUT THE EXPENSE AND INSTABILITY
C         OF CONTINUATION BY TAYLOR SERIES NOT ONLY GOES UP, BUT THE
C         COMPUTATIONAL EXPENSE BECOMES EXCESSIVELY LARGE IN OTHER PARTS
C         OF THE LEFT HALF PLANE (Y.LT.YB) WHERE THE BACKWARD RECURRENCE
C         ALGORITHM WOULD CONVERGE RAPIDLY.
C
C         DERIVATIVES FOR SUCCESSIVE POWER SERIES ARE NOT COMPUTED BY
C         EVALUATING DERIVATIVES OF A PREVIOUS POWER SERIES. BECAUSE OF
C         THE RELATION
C
C           (1)           DE(N,Z)/DZ = - E(N-1,Z),
C
C         SUCCESSIVE DERIVATIVES AT Z ARE GIVEN BY LOWER ORDER FUNCTIONS
C         AND CAN BE COMPUTED IN A STABLE FASHION BY BACKWARD RECURRENCE
C         USING (2) PROVIDED THAT THE BEGINNING ORDER NUB IS SMALLER
C         THAN THE ARGUMENT. TO ACHIEVE THIS FOR ALL INTERMEDIATE VALUES
C         ZZ BETWEEN ZB AND Z, WE TAKE NUB=MINO(N+M-1,INT(CABS(Z)+0.5)).
C         TO START, E(NUB,ZB) IS EVALUATED BY THE BACKWARD RECURRENCE
C         ALGORITHM OF REF. 3. TO CONTINUE THE FUNCTION FROM ZB TO Z VIA
C         INTERMEDIATE VALUES ZZ, DERIVATIVES OF E(NUB,ZB) ARE COMPUTED
C         BY BACKWARD RECURRENCE ON (2). THIS ALLOWS A STEP (NO LARGER
C         THAN 0.5) TO ZZ FOR E(NUB,ZZ) USING THE TAYLOR SERIES ABOUT
C         ZB. NOW, WE APPLY (2) AGAIN STARTING AT E(NUB,ZZ) FOR THE DE-
C         RIVATIVES AT ZZ AND TAKE ANOTHER STEP, ETC. NOTICE THAT THE
C         STABILITY CONDITION FOR BACKWARD RECURRENCE, NUB.LE.CABS(Z)
C         .LE.CABS(ZZ).LE.CABS(ZB), IS SATISFIED FOR ALL INTERMEDIATE
C         VALUES ZZ. THE FINAL SEQUENCE FOR ORDERS N,...,N+M-1 IS GEN-
C         ERATED FROM (2) BY BACKWARD RECURRENCE, FORWARD RECURRENCE
C         OR BOTH ONCE E(NUB,Z) HAS BEEN COMPUTED.
C
C         RECURRENCE WITH THE RELATION
C
C            (2)     N*E(N+1,Z) + Z*E(N,Z) = CEXP(-Z)
C
C         IN A DIRECTION AWAY FROM THE INTEGER CLOSEST TO CABS(Z) IS
C         STABLE. FOR NEGATIVE ORDERS, THE RECURRENCE
C
C               E( 0,Z) = CEXP(-Z)/Z
C               E(-N,Z) = ( CEXP(-Z)+N*E(-N+1,Z) )/Z   ,N=1,2,...
C
C         IS NUMERICALLY STABLE FOR ALL Z.
C
C         THE (CAPITAL) SINE AND COSINE INTEGRALS CAN BE COMPUTED FROM
C
C                 SI(Z) =  (E(1,I*Z)-E(1,-I*Z))/(2*I) + PI/2
C                 CI(Z) = -(E(1,I*Z)+E(1,-I*Z))/2
C
C         IN -PI/2.LT.ARG(Z).LE.PI/2, (I**2=-1), WHILE THE PRINCIPAL
C         VALUED EXPONENTIAL INTEGRAL EI(X) CAN BE COMPUTED FROM
C
C             EI( X) = -(E(1,-X+I*0)+E(1,-X-I*0))/2 = -REAL(E(1,-X))
C             EI(-X) = -REAL(E(1,X))
C
C         FOR X.GT.0.0 TO AN ACCURACY TOL. IF Z = X.GT.0 THEN THE
C         REAL SINE AND COSINE INTEGRALS ARE GIVEN BY
C
C                 SI(X) = AIMAG(E(1,I*X)) + PI/2
C                 CI(X) = -REAL(E(1,I*X)) .
C
C         THE ANALYTIC CONTINUATION TO OTHER SHEETS CAN BE DONE BY
C         THE RELATIONS
C
C         E(N,Z*CEXP(2*PI*M*I)) = E(N,Z) - 2*PI*M*I*(-Z)**(N-1)/(N-1)!
C
C         WHERE M=+1 OR M=-1 AND I**2=-1.
C
C***REFERENCES  HANDBOOK OF MATHEMATICAL FUNCTIONS BY M. ABRAMOWITZ
C                 AND I. A. STEGUN, NBS AMS SERIES 55, U.S. DEPT. OF
C                 COMMERCE, 1955.
C
C               COMPUTATION OF EXPONENTIAL INTEGRALS OF COMPLEX ARGUMENT
C                 BY D. E. AMOS, ACM TRANS. MATH. SOFTWARE
C
C               COMPUTATION OF EXPONENTIAL INTEGRALS
C                 BY D. E. AMOS, ACM TRANS. MATH. SOFTWARE, VOL 6, NO. 3
C                 SEPTEMBER 1980, PP. 365-377; ALGORITHM 556, EXPONEN-
C                 TIAL INTEGRALS, PP. 420-428.
C
C               REMARK ON ALGORITHM 556
C                 BY D. E. AMOS, ACM TRANS. MATH. SOFTWARE, VOL 9, NO. 4
C                 DECEMBER 1983, P. 525.
C
C               UNIFORM ASYMPTOTIC EXPANSIONS FOR EXPONENTIAL INTE-
C                 GRALS E(N,X) AND BICKLEY FUNCTIONS KI(N,X) BY D. E.
C                 AMOS, ACM TRANS. MATH. SOFTWARE, VOL 9, NO. 4,
C                 DECEMBER. 1983, PP. 467-479; ALGORITHM 609, A PORTA-
C                 BLE FORTRAN SUBROUTINE FOR BICKLEY FUNCTIONS KI(N,X),
C                 PP. 480-493.
C
C***ROUTINES CALLED  CACEXI,CEXENZ,I1MACH,R1MACH
C***END PROLOGUE  CEXINT
C
C
      INTEGER I, ICDIM, IERR, K, KODE, K1, K2, M, N, I1MACH
      REAL AA, ALIM, AZ, BB, CA, D, ELIM, FN, RBRY, R1M5, TOL, URND, X,
     * Y, YB, HTOL, R1MACH
      COMPLEX Z, CY, CB
C-----------------------------------------------------------------------
C     DIMENSION CA(ICDIM),CB(ICDIM)
C-----------------------------------------------------------------------
      DIMENSION CY(M), CA(250), CB(250)
      DATA ICDIM /250/
C***FIRST EXECUTABLE STATEMENT  CEXINT
      IERR = 0
      X = REAL(Z)
      Y = AIMAG(Z)
      IF (X.EQ.0.0E0 .AND. Y.EQ.0.0E0 .AND. N.EQ.1) IERR = 1
      IF (N.LT.1) IERR = 1
      IF (KODE.LT.1 .OR. KODE.GT.2) IERR = 1
      IF (M.LT.1) IERR = 1
      URND = AMAX1(R1MACH(4),1.0E-18)
      IF (TOL.LT.URND .OR. TOL.GT.1.0E-3) IERR = 1
      IF (IERR.NE.0) RETURN
      IF (X.EQ.0.0E0 .AND. Y.EQ.0.0E0 .AND. N.GT.1) GO TO 40
C-----------------------------------------------------------------------
C     SET PARAMETERS RELATED TO MACHINE CONSTANTS.
C     URND IS THE APPROXIMATE UNIT ROUNDOFF LIMITED TO 1.0E-18.
C     ELIM IS THE APPROXIMATE EXPONENTIAL OVER- AND UNDERFLOW LIMIT.
C     EXP(-ELIM).LT.EXP(-ALIM)=EXP(-ELIM)/URND    AND
C     EXP(ELIM).GT.EXP(ALIM)=EXP(ELIM)*URND       ARE INTERVALS NEAR
C     UNDERFLOW AND OVERFLOW LIMITS WHERE SCALED ARITHMETIC IS DONE.
C-----------------------------------------------------------------------
      K1 = I1MACH(12)
      K2 = I1MACH(13)
      R1M5 = R1MACH(5)
      K = MIN0(IABS(K1),IABS(K2))
      ELIM = 2.303E0*(FLOAT(K)*R1M5-3.0E0)
      K1 = I1MACH(11) - 1
      AA = R1M5*FLOAT(K1)
      AA = AA*2.303E0
      ALIM = ELIM + AMAX1(-AA,-41.45E0)
      RBRY = 2.0E0
      IF (URND.GT.1.0E-8) RBRY = 1.0E0
C-----------------------------------------------------------------------
C     TEST VARIABLES FOR RANGE. CABS(Z) CANNOT BE LARGER THAN THE ARG-
C     UMENT OF THE INT( ) FUNCTION.
C-----------------------------------------------------------------------
      AZ = CABS(Z)
      FN = FLOAT(N+M-1)
      AA = 0.5E0/URND
      BB = FLOAT(I1MACH(9))*0.5E0
      AA = AMIN1(AA,BB)
      IF (AZ.GT.AA) GO TO 60
      IF (FN.GT.AA) GO TO 60
      AA = SQRT(AA)
      IF (AZ.GT.AA) IERR = 4
      IF (FN.GT.AA) IERR = 4
      IF (X.LT.0.0E0) GO TO 10
C-----------------------------------------------------------------------
C     BACKWARD RECURRENCE FOR THE RIGHT HALF PLANE, X.GE.0.0E0
C-----------------------------------------------------------------------
      CALL CEXENZ(Z, N, KODE, M, CY, IERR, RBRY, TOL, ELIM, ALIM,
     * ICDIM, CA, CB)
      RETURN
   10 CONTINUE
      IF (AZ.GT.RBRY) GO TO 20
C-----------------------------------------------------------------------
C     POWER SERIES FOR CABS(Z).LE.RBRY AND X.LT.0.0E0
C-----------------------------------------------------------------------
      CALL CEXENZ(Z, N, KODE, M, CY, IERR, RBRY, TOL, ELIM, ALIM,
     * ICDIM, CA, CB)
      RETURN
   20 CONTINUE
      D = -0.4342945E0*ALOG(TOL)
      YB = 10.5E0 - 0.538460E0*(18.0E0-D)
      IF (ABS(Y).LT.YB) GO TO 30
C-----------------------------------------------------------------------
C     BACKWARD RECURRENCE EXTERIOR TO THE STRIP ABS(Y).LT.YB, X.LT.0.0
C-----------------------------------------------------------------------
      HTOL = 0.125E0*TOL
      CALL CEXENZ(Z, N, KODE, M, CY, IERR, RBRY, HTOL, ELIM, ALIM,
     * ICDIM, CA, CB)
      RETURN
   30 CONTINUE
C-----------------------------------------------------------------------
C     TAYLOR SERIES IN CACEXI FOR ANALYTIC CONTINUATION
C-----------------------------------------------------------------------
      CALL CACEXI(Z, N, KODE, M, CY, IERR, YB, RBRY, TOL, ELIM, ALIM,
     * ICDIM, CA, CB)
      RETURN
   40 CONTINUE
      DO 50 I=1,M
        CY(I) = CMPLX(1.0E0/FLOAT(N+I-2),0.0E0)
   50 CONTINUE
      RETURN
   60 CONTINUE
      IERR = 5
      RETURN
      END
c
c
      SUBROUTINE CEXENZ(Z, N, KODE, M, CY, IERR, RBRY, TOL, ELIM, ALIM,
     * ICDIM, CA, CB)
C***BEGIN PROLOGUE  CEXENZ
C***REFER TO  CEXINT
C
C      CEXENZ COMPUTES THE EXPONENTIAL INTEGRAL BY MEANS OF POWER SERIES
C      AND A BACKWARD RECURRENCE ALGORITHM FOR THE CONFLUENT HYPER-
C      GEOMETRIC REPRESENTATION.
C
C***ROUTINES CALLED PSIXN
C***END PROLOGUE  CEXENZ
C
      INTEGER I, IC, ICASE, ICDIM, ICMAX, ICT, IERR, IK, IND, IZ, JSET,
     * K, KFLAG, KN, KODE, KS, M, ML, MU, N, ND, NM
      REAL AA, AAM, AAMS, AEM, AH, AK, ALIM, AP1, AT, AZ, BK, BT, CA,
     * DK, ELIM, ERR, EULER, FC, FNM, RBRY, RTOLA, TOL, TOLA, X, XTOL,
     * Y, CK, PSIXN
      COMPLEX CP1, CP2, CPT, CAT, CBT, CY1, CY2, CY(M), CYY(2),
     * CNORM, CB, Z, CS, CAK, EMZ, CAA, TZ, FZ, CT, CZERO, CONE,
     * SCLE, RSCLE
      DIMENSION CA(ICDIM), CB(ICDIM)
      DATA EULER /-5.77215664901532861E-01/
      DATA CZERO, CONE  /(0.0E0,0.0E0), (1.0E0,0.0E0)/
      DATA ICMAX /2000/
      SCLE = CONE
      RSCLE = CONE
      X = REAL(Z)
      Y = AIMAG(Z)
      AZ = CABS(Z)
      IF (AZ.GT.RBRY) GO TO 80
C-----------------------------------------------------------------------
C     SERIES FOR E(N,Z) FOR CABS(Z).LE.RBRY
C-----------------------------------------------------------------------
      IZ = INT(AZ+0.5E0)
C-----------------------------------------------------------------------
C     ICASE=1 MEANS INTEGER CLOSEST TO CABS(Z) IS 2 AND N=1
C     ICASE=2 MEANS INTEGER CLOSEST TO CABS(Z) IS 0,1, OR 2 AND N.GE.2
C-----------------------------------------------------------------------
      ICASE = 2
      IF (IZ.GT.N) ICASE = 1
      NM = N - ICASE + 1
      ND = NM + 1
      IND = 3 - ICASE
      MU = M - IND
      ML = 1
      KS = ND
      FNM = FLOAT(NM)
      CS = CZERO
      XTOL = 0.3333E0*TOL
      AAM = 1.0E0
      IF (ND.EQ.1) GO TO 10
      AAM = 1.0E0/FNM
      CS = CMPLX(AAM,0.0E0)
   10 CONTINUE
      CAA = CONE
      AA = 1.0E0
      AK = 1.0E0
C-----------------------------------------------------------------------
C     LIMIT INDEX I TO IK TO PREVENT UNDERFLOW ON SMALL VALUES OF Z
C-----------------------------------------------------------------------
      IK = 35
      IF (AZ.LT.XTOL*AAM) IK = 1
      DO 50 I=1,IK
        AT=1.0E0/AK
        CAA = -CAA*Z*CMPLX(AT,0.0E0)
        AA=AA*AZ*AT
        IF (I.EQ.NM) GO TO 30
        CS = CS - CAA*CMPLX(1.0E0/(AK-FNM),0.0E0)
        GO TO 40
   30   CONTINUE
        CS = CS + CAA*(-CLOG(Z)+CMPLX(PSIXN(ND),0.0E0))
   40   CONTINUE
        IF (AA.LE.XTOL*CABS(CS)) GO TO 60
        AK = AK+1.0E0
   50 CONTINUE
   60 CONTINUE
      IF (ND.EQ.1) CS = CS + (-CLOG(Z)+CMPLX(EULER,0.0E0))
      IF (KODE.EQ.2) CS = CS*CEXP(Z)
      CY(1) = CS
      CT = CS
      EMZ = CONE
      IF (M.EQ.1) GO TO 70
      CY(IND) = CS
      AK = FLOAT(KS)
      IF (KODE.EQ.1) EMZ = CEXP(-Z)
      GO TO (300, 320), ICASE
   70 CONTINUE
      IF (ICASE.EQ.2) RETURN
      IF (KODE.EQ.1) EMZ = CEXP(-Z)
      CY(1) = (EMZ-CS)/Z
      RETURN
C-----------------------------------------------------------------------
C     BACKWARD RECURSIVE MILLER ALGORITHM FOR
C              E(N,Z)=EXP(-Z)*(Z**(N-1))*U(N,N,Z)
C     WITH RECURSION AWAY FROM N=INTEGER CLOSEST TO CABS(Z)
C     U(A,B,Z) IS THE SECOND CONFLUENT HYPERGEOMETRIC FUNCTION
C-----------------------------------------------------------------------
   80 CONTINUE
      EMZ = CONE
      IF (KODE.EQ.2) GO TO 140
C-----------------------------------------------------------------------
C     SCALE NEAR EXPONENT EXTREMES ON KODE=1
C-----------------------------------------------------------------------
      IF (X.LT.0.0E0) GO TO 90
      AT = X + FLOAT(N+M-1)
      CT = CMPLX(AT,Y)
      AA = CABS(CT)
      AT = X + ALOG(AA)
      IF (AT.GT.ELIM) GO TO 150
      KFLAG = 1
      GO TO 100
   90 CONTINUE
      AT = X
      IF (AT.LT.(-ELIM)) GO TO 340
      KFLAG = 2
  100 CONTINUE
      IF (ABS(AT).LT.ALIM) GO TO 130
      TOLA = EXP(ALIM-ELIM)
      RTOLA = 1.0E0/TOLA
      IF (KFLAG.EQ.2) GO TO 110
      SCLE = CMPLX(RTOLA,0.0E0)
      RSCLE = CMPLX(TOLA,0.0E0)
      GO TO 120
  110 CONTINUE
      SCLE = CMPLX(TOLA,0.0E0)
      RSCLE = CMPLX(RTOLA,0.0E0)
  120 CONTINUE
      EMZ = SCLE
  130 CONTINUE
      EMZ = EMZ*CEXP(-Z)
  140 CONTINUE
      IZ = INT(AZ+0.5E0)
      KN = N + M - 1
      IF (KN.LE.IZ) GO TO 170
      IF (N.LT.IZ .AND. IZ.LT.KN) GO TO 200
      IF (N.GE.IZ) GO TO 190
      IERR=7
      RETURN
  150 CONTINUE
      IERR = 2
      DO 160 I=1,M
        CY(I) = CZERO
  160 CONTINUE
      RETURN
  170 CONTINUE
      ICASE = 1
      KS = KN
      ML = M - 1
      MU = -1
      IND = M
      IF (KN.GT.1) GO TO 210
  180 CONTINUE
      KS = 2
      ICASE = 3
      GO TO 210
  190 CONTINUE
      ICASE = 2
      IND = 1
      KS = N
      MU = M - 1
      IF (N.GT.1) GO TO 210
      IF (KN.EQ.1) GO TO 180
      IZ = 2
  200 CONTINUE
      ICASE = 1
      KS = IZ
      ML = IZ - N
      IND = ML + 1
      MU = KN - IZ
  210 CONTINUE
      IK = KS/2
      AH = FLOAT(IK)
      JSET = 1 + KS - 2*IK
C-----------------------------------------------------------------------
C     START COMPUTATION FOR
C              CYY(1) = C*U( A , A ,Z)    JSET=1
C              CYY(1) = C*U(A+1,A+1,Z)    JSET=2
C     FOR AN EVEN INTEGER A.
C-----------------------------------------------------------------------
      IC = 0
      AA = AH + AH
      CAA = CMPLX(AA,0.0E0)
      AAM = AA - 1.0E0
      AAMS = AAM*AAM
      TZ = Z + Z
      FZ = TZ + TZ
      AK = AH
      XTOL = TOL
      CT = CMPLX(AAMS,0.0E0) + FZ*CMPLX(AH,0.0E0)
      CAK = Z + CAA
      AEM = (AK+1.0E0)/XTOL
      AEM = AEM/CABS(CAK)
      BK = AA
      CK = AH*AH
C-----------------------------------------------------------------------
C     FORWARD RECURSION FOR P(IC),P(IC+1) AND INDEX IC FOR BACKWARD
C     RECURSION
C-----------------------------------------------------------------------
      CP1 = CZERO
      CP2 = CONE
  220 CONTINUE
      IC = IC + 1
      IF (IC.GT.ICDIM) GO TO 230
      AK = AK + 1.0E0
      CK = CK + 1.0E0
      AT = BK/(BK+AK+CK)
      BK = BK + AK + AK
      CAT = CMPLX(AT,0.0E0)
      CA(IC) = AT
      BT = 1.0E0/(AK+1.0E0)
      CBT = (CMPLX(AK+AK,0.0E0)+Z)*CMPLX(BT)
      CB(IC) = CBT
      CPT = CP2
      CP2 = CBT*CP2 - CAT*CP1
      CP1 = CPT
      CT = CT + FZ
      AEM = AEM*AT
      BT = CABS(CT)
      ERR = AEM/SQRT(BT)
      AP1 = CABS(CP1)
      IF (ERR*(AK+1.0E0)/AP1.GT.AP1) GO TO 220
      GO TO 250
C-----------------------------------------------------------------------
C     CONTINUE FORWARD RECURRENCE UNINDEXED WHEN IC EXCEEDS ICDIM
C-----------------------------------------------------------------------
  230 CONTINUE
      IC = IC - 1
  240 CONTINUE
      IC = IC + 1
      IF (IC.GT.ICMAX) GO TO 350
      AK = AK + 1.0E0
      CK = CK + 1.0E0
      AT = BK/(BK+AK+CK)
      BK = BK + AK + AK
      CAT = CMPLX(AT,0.0E0)
      BT = 1.0E0/(AK+1.0E0)
      CBT = (CMPLX(AK+AK,0.0E0)+Z)*CMPLX(BT)
      CPT = CP2
      CP2 = CBT*CP2 - CAT*CP1
      CP1 = CPT
      CT = CT + FZ
      AEM = AEM*AT
      BT = CABS(CT)
      ERR = AEM/SQRT(BT)
      AP1 = CABS(CP1)
      IF (ERR*(AK+1.0E0)/AP1.GT.AP1) GO TO 240
  250 CONTINUE
      FC = FLOAT(IC)
      AT = ((FC+1.0E0)/(AK+1.0E0))*((AK+AH)/(AK+1.0E0))
      CAT = CMPLX(AT,0.0E0)*CSQRT(CT/(CT+FZ))
      CY2 = CAT*(CP1/CP2)
      CY1 = CONE
C-----------------------------------------------------------------------
C     BACKWARD RECURRENCE FOR
C             CY1=             C*U( A ,A,Z)
C             CY2= C*(A/(1+A/2))*U(A+1,A,Z)
C-----------------------------------------------------------------------
      IF (IC.LE.ICDIM) GO TO 270
C-----------------------------------------------------------------------
C     BACKWARD RECUR UNINDEXED WHEN IC EXCEEDS ICDIM
C-----------------------------------------------------------------------
      BT = AA + X
  260 CONTINUE
      AK = AH + FC
      BK = AK + 1.0E0
      CK = AAM + FC
      DK = BT + FC + FC
      AT = (AK/FC)*(BK/CK)
      CBT = CMPLX(DK/BK,Y/BK)
      CPT = CY1
      CY1 = (CBT*CY1-CY2)*CMPLX(AT,0.0E0)
      CY2 = CPT
      FC = FC - 1.0E0
      IC = IC - 1
      IF (IC.GT.ICDIM) GO TO 260
  270 CONTINUE
      ICT = IC
      DO 280 K=1,ICT
        AT = 1.0E0/CA(IC)
        CPT = CY1
        CY1 = (CB(IC)*CY1-CY2)*CMPLX(AT,0.0E0)
        CY2 = CPT
        IC = IC - 1
  280 CONTINUE
C-----------------------------------------------------------------------
C     THE CONTIGUOUS RELATION
C              Z*U(B,C+1,Z)=(C-B)*U(B,C,Z)+U(B-1,C,Z)
C     WITH  B=A+1 , C=A IS USED FOR
C             CYY(2) = C * U(A+1,A+1,Z)
C     Z IS INCORPORATED INTO THE NORMALIZING RELATION FOR CNORM.
C-----------------------------------------------------------------------
      CPT = CY2/CY1
      CNORM = CONE - CPT*CMPLX((AH+1.0E0)/AA,0.0E0)
      CYY(1) = CONE/(CNORM*CAA+Z)
      CYY(2) = CNORM*CYY(1)
      IF (ICASE.EQ.3) GO TO 290
      CT = EMZ*CYY(JSET)
      CY(IND) = CT*RSCLE
      CS = CT
      IF (M.EQ.1) RETURN
      AK = FLOAT(KS)
      GO TO (300, 320), ICASE
C-----------------------------------------------------------------------
C     RECURSION SECTION  N*E(N+1,Z) + Z*E(N,Z)=EMZ
C-----------------------------------------------------------------------
  290 CONTINUE
      CT = EMZ*(CONE-CYY(1))/Z
      CY(1) = CT*RSCLE
      RETURN
  300 CONTINUE
      CAA = CMPLX(AK,0.0E0)
      TZ = CONE/Z
      K = IND - 1
      DO 310 I=1,ML
        CAA = CAA - CONE
        CT = (EMZ-CAA*CT)*TZ
        CY(K) = CT*RSCLE
        K = K - 1
  310 CONTINUE
      IF (MU.LE.0) RETURN
      AK = FLOAT(KS)
  320 CONTINUE
      K = IND
      DO 330 I=1,MU
        CS = (EMZ-Z*CS)*CMPLX(1.0E0/AK,0.0E0)
        CY(K+1) = CS*RSCLE
        AK = AK + 1.0E0
        K = K + 1
  330 CONTINUE
      RETURN
  340 CONTINUE
      IERR = 3
      RETURN
  350 CONTINUE
      IERR = 6
      RETURN
      END
c
c
      SUBROUTINE CACEXI(Z, NU, KODE, N, Y, IERR, YB, RBRY, TOL, ELIM,
     * ALIM, ICDIM, CA, CB)
C***BEGIN PROLOGUE  CACEXI
C***REFER TO  CEXINT
C
C     CACEXI COMPUTES THE ANALYTIC CONTINUATION OF THE EXPONENTIAL
C     INTEGRAL FOR X.LT.0 AND -YB.LT.Y.LT.YB BY TAYLOR SERIES IN
C     INCREMENTS OF HALF A UNIT. THE CONTINUATION PROCEEDS
C     VERTICALLY DOWN FROM ZB=CMPLX(X,YB) TO Z=CMPLX(X,Y) FOR 0.0.LE.
C     Y.LT.YB. CONJUGATION IS USED FOR Y.LT.0.0E0.
C
C***ROUTINES CALLED  CEXENZ
C***END PROLOGUE  CACEXI
C
      INTEGER I, IAZ, ICDIM, IERR, IL, IS, IY, K, KB,  KL, KMAX,
     * KODE, KS, KYB, N, NB, NFLG, NU, NUB
      REAL ALIM, AZ, CA, DEL, ELIM, FK, RBRY, RTOLA, TOL, TOLA, YB,
     * YT, ZI, ZID, ZR, XTOL, RZI, ATRM, FJ, RW, RQ(64), ASUM, HTOL
      COMPLEX Y(N), YY(1), CONE, CEX, SUM, TRM, Z, ZZ, ZP(64), ZT, SCLE,
     * RSCLE, TRMS, CB, ZW, CEZT
      DIMENSION CA(ICDIM), CB(ICDIM)
      DATA CONE /(1.0E0,0.0E0)/
      SCLE = CONE
      RSCLE = CONE
      ZR = REAL(Z)
      ZI = AIMAG(Z)
      ZID = ZI
      KYB = 0
      IF (ZI.LT.0.0E0) ZID = -ZID
      AZ = CABS(Z)
      IAZ = INT(AZ+0.5E0)
C-----------------------------------------------------------------------
C     SET ORDER NUB=MIN0(N+M-1,INT(CABS(Z)+0.5)), GENERATE REMAINDER
C     OF THE SEQUENCE AFTER THE COMPUTATION OF E(NUB,Z)
C-----------------------------------------------------------------------
      IF (NU.GE.IAZ) GO TO 10
      IF (NU+N-1.LE.IAZ) GO TO 20
      NUB = IAZ
      NB = 0
      NFLG = 3
      KB = NUB - NU + 1
      KS = KB + 1
      KL = N
      IS = 1
      IL = KB - 1
      GO TO 40
   10 CONTINUE
      NUB = MAX0(IAZ,1)
      NB = NU - NUB
      NFLG = 1
      KB = 1
      KS = 2
      KL = N
      GO TO 40
   20 CONTINUE
      NUB = NU + N - 1
      NB = 0
      NFLG = 2
      IS = 2
      IL = N
      KB = N
      GO TO 40
C-----------------------------------------------------------------------
C     SET PARAMETERS FOR ANALYTIC CONTINUATION FROM Y=YB INTO THE REGION
C     0.LE.ZID.LT.YB.
C-----------------------------------------------------------------------
   30 CONTINUE
      YB = YB + 0.5E0
      KYB = KYB + 1
      IF (KYB.GT.10) RETURN
      IERR = 0
   40 CONTINUE
      DEL = YB - ZID
C-----------------------------------------------------------------------
C     MAKE DEL LARGE ENOUGH TO AVOID UNDERFLOW IN GENERATION OF POWERS
C-----------------------------------------------------------------------
      IF(ABS(DEL).GT.1.0E-4) GO TO 50
      YB = YB + 1.0E-4
      DEL = YB - ZID
   50 CONTINUE
      HTOL = 0.125E0*TOL
      ZZ = CMPLX(ZR,YB)
      CALL CEXENZ(ZZ,NUB,2,1,YY,IERR,RBRY,HTOL,ELIM,ALIM,ICDIM,CA,CB)
      IF(IERR.EQ.6) GO TO 30
C-----------------------------------------------------------------------
C     ANALYTIC CONTINUATION VIA TAYLOR SERIES FOR ORDER NUB
C-----------------------------------------------------------------------
      IY=INT(DEL+DEL)
      YT=DEL/FLOAT(IY+1)
      SUM=YY(1)
      HTOL=0.25E0*TOL
      TRM=SUM
      CEZT=CMPLX(COS(YT),-SIN(YT))
      ZW=CONE
      ZP(1)=CONE
      FK=1.0E0
      FJ=FLOAT(NUB-1)
      ZT=CONE/ZZ
C-----------------------------------------------------------------------
C     TERMS OF THE SERIES TRM=E(NUB-K,ZZ)*(YT**K)/K!,  K=0,1,... ARE
C     GENERATED BY BACKWARD RECURRENCE. E IS SCALED BY CEXP(ZZ).
C-----------------------------------------------------------------------
      DO 60 K=2,64
        RW=YT/FK
        ZW=ZW*CMPLX(0.0E0,RW)
        RW = FJ*RW
        TRM=(ZW-CMPLX(0.0E0,RW)*TRM)*ZT
        SUM=SUM+TRM
        ZP(K)=ZW
        RQ(K)=RW
        ASUM=CABS(SUM)
        ATRM=CABS(TRM)
        IF(ATRM.LT.HTOL*ASUM) GO TO 70
        FK=FK+1.0E0
        FJ=FJ-1.0E0
   60 CONTINUE
      K=64
   70 CONTINUE
      KMAX=K
      SUM=SUM*CEZT
      IF(IY.EQ.0) GO TO 100
      DO 90 I=1,IY
        RZI=FLOAT(IY-I+1)*YT+ZID
        ZZ=CMPLX(ZR,RZI)
        ZT=CONE/ZZ
        TRM=SUM
        DO 80 K=2,KMAX
          TRM=(ZP(K)-CMPLX(0.0E0,RQ(K))*TRM)*ZT
          SUM=SUM+TRM
   80   CONTINUE
        ATRM=CABS(TRM)
        ASUM=CABS(SUM)
        XTOL=HTOL*ASUM
        IF(ATRM.LT.XTOL) GO TO 86
        IF(KMAX.GE.64) GO TO 86
        KMAX=KMAX+1
        DO 84 K=KMAX,64
          RW=YT/FK
          ZW=ZW*CMPLX(0.0E0,RW)
          RW=FJ*RW
          TRM=(ZW-CMPLX(0.0E0,RW)*TRM)*ZT
          SUM=SUM+TRM
          ZP(K)=ZW
          RQ(K)=RW
          ATRM=CABS(TRM)
          IF(ATRM.LT.XTOL) GO TO 85
          FK=FK+1.0E0
          FJ=FJ-1.0E0
   84   CONTINUE
        K=64
   85   CONTINUE
        KMAX=K
   86   CONTINUE
        SUM=SUM*CEZT
   90 CONTINUE
  100 CONTINUE
C-----------------------------------------------------------------------
C     FORM SEQUENCE UP OR DOWN FROM ORDER NUB
C-----------------------------------------------------------------------
      IF (ZI.LT.0.0E0) SUM = CONJG(SUM)
      CEX = CONE
C-----------------------------------------------------------------------
C     SCALE NEAR OVERFLOW LIMIT ON KODE=1
C-----------------------------------------------------------------------
      IF (KODE.EQ.2) GO TO 160
      IF (ABS(ZR).LT.ALIM) GO TO 150
      IF (ABS(ZR).GT.ELIM) GO TO 220
      TOLA = EXP(ALIM-ELIM)
      RTOLA = 1.0E0/TOLA
      SCLE = CMPLX(TOLA,0.0E0)
      RSCLE = CMPLX(RTOLA,0.0E0)
  150 CONTINUE
      CEX = SCLE*CEXP(-Z)
  160 CONTINUE
      TRM = SUM*CEX
      Y(KB) = TRM*RSCLE
      TRMS = TRM
      IF (N.EQ.1 .AND. NFLG.NE.1) RETURN
      IF (NFLG.EQ.2) GO TO 200
      FK = FLOAT(NUB)
      IF (NFLG.NE.1 .OR. NB.EQ.0) GO TO 180
      DO 170 K=1,NB
        TRM = (CEX-Z*TRM)*CMPLX(1.0E0/FK,0.0E0)
        FK = FK + 1.0E0
  170 CONTINUE
  180 CONTINUE
      Y(KB) = TRM*RSCLE
      TRMS = TRM
      IF (N.EQ.1) RETURN
      DO 190 K=KS,KL
        TRM = (CEX-Z*TRM)*CMPLX(1.0E0/FK,0.0E0)
        Y(K) = TRM*RSCLE
        FK = FK + 1.0E0
  190 CONTINUE
      IF (NFLG.EQ.1) RETURN
  200 CONTINUE
      K = KB - 1
      FK = FLOAT(NUB-1)
      ZT=CONE/Z
      DO 210 I=IS,IL
        TRMS = (CEX-CMPLX(FK,0.0E0)*TRMS)*ZT
        Y(K) = TRMS*RSCLE
        K = K - 1
        FK = FK - 1.0E0
  210 CONTINUE
      RETURN
  220 CONTINUE
      IERR = 3
      RETURN
      END
      FUNCTION PSIXN(N)
C***BEGIN PROLOGUE  PSIXN
C***REFER TO  EXINT,BSKIN
C
C     THIS SUBROUTINE RETURNS VALUES OF PSI(X)=DERIVATIVE OF LOG
C     GAMMA(X), X.GT.0.0 AT INTEGER ARGUMENTS. A TABLE LOOK-UP IS
C     PERFORMED FOR N.LE.100, AND THE ASYMPTOTIC EXPANSION IS
C     EVALUATED FOR N.GT.100.
C
C***ROUTINES CALLED  R1MACH
C***END PROLOGUE  PSIXN
C
      INTEGER N, K
      REAL AX, B, C, FN, RFN2, TRM, S, WDTOL
      REAL R1MACH, PSIXN
      DIMENSION B(6), C(100)
C-----------------------------------------------------------------------
C             PSIXN(N), N = 1,100
C-----------------------------------------------------------------------
      DATA C(1), C(2), C(3), C(4), C(5), C(6), C(7), C(8), C(9), C(10),
     1     C(11), C(12), C(13), C(14), C(15), C(16), C(17), C(18),
     2     C(19), C(20), C(21), C(22), C(23), C(24)/
     3    -5.77215664901532861E-01,     4.22784335098467139E-01,
     4     9.22784335098467139E-01,     1.25611766843180047E+00,
     5     1.50611766843180047E+00,     1.70611766843180047E+00,
     6     1.87278433509846714E+00,     2.01564147795561000E+00,
     7     2.14064147795561000E+00,     2.25175258906672111E+00,
     8     2.35175258906672111E+00,     2.44266167997581202E+00,
     9     2.52599501330914535E+00,     2.60291809023222227E+00,
     A     2.67434666166079370E+00,     2.74101332832746037E+00,
     B     2.80351332832746037E+00,     2.86233685773922507E+00,
     C     2.91789241329478063E+00,     2.97052399224214905E+00,
     D     3.02052399224214905E+00,     3.06814303986119667E+00,
     E     3.11359758531574212E+00,     3.15707584618530734E+00/
      DATA C(25), C(26), C(27), C(28), C(29), C(30), C(31), C(32),
     1     C(33), C(34), C(35), C(36), C(37), C(38), C(39), C(40),
     2     C(41), C(42), C(43), C(44), C(45), C(46), C(47), C(48)/
     3     3.19874251285197401E+00,     3.23874251285197401E+00,
     4     3.27720405131351247E+00,     3.31424108835054951E+00,
     5     3.34995537406483522E+00,     3.38443813268552488E+00,
     6     3.41777146601885821E+00,     3.45002953053498724E+00,
     7     3.48127953053498724E+00,     3.51158256083801755E+00,
     8     3.54099432554389990E+00,     3.56956575411532847E+00,
     9     3.59734353189310625E+00,     3.62437055892013327E+00,
     A     3.65068634839381748E+00,     3.67632737403484313E+00,
     B     3.70132737403484313E+00,     3.72571761793728215E+00,
     C     3.74952714174680596E+00,     3.77278295570029433E+00,
     D     3.79551022842756706E+00,     3.81773245064978928E+00,
     E     3.83947158108457189E+00,     3.86074817682925274E+00/
      DATA C(49), C(50), C(51), C(52), C(53), C(54), C(55), C(56),
     1     C(57), C(58), C(59), C(60), C(61), C(62), C(63), C(64),
     2     C(65), C(66), C(67), C(68), C(69), C(70), C(71), C(72)/
     3     3.88158151016258607E+00,     3.90198967342789220E+00,
     4     3.92198967342789220E+00,     3.94159751656514710E+00,
     5     3.96082828579591633E+00,     3.97969621032421822E+00,
     6     3.99821472884273674E+00,     4.01639654702455492E+00,
     7     4.03425368988169777E+00,     4.05179754953082058E+00,
     8     4.06903892884116541E+00,     4.08598808138353829E+00,
     9     4.10265474805020496E+00,     4.11904819067315578E+00,
     A     4.13517722293122029E+00,     4.15105023880423617E+00,
     B     4.16667523880423617E+00,     4.18205985418885155E+00,
     C     4.19721136934036670E+00,     4.21213674247469506E+00,
     D     4.22684262482763624E+00,     4.24133537845082464E+00,
     E     4.25562109273653893E+00,     4.26970559977879245E+00/
      DATA C(73), C(74), C(75), C(76), C(77), C(78), C(79), C(80),
     1     C(81), C(82), C(83), C(84), C(85), C(86), C(87), C(88),
     2     C(89), C(90), C(91), C(92), C(93), C(94), C(95), C(96)/
     3     4.28359448866768134E+00,     4.29729311880466764E+00,
     4     4.31080663231818115E+00,     4.32413996565151449E+00,
     5     4.33729786038835659E+00,     4.35028487337536958E+00,
     6     4.36310538619588240E+00,     4.37576361404398366E+00,
     7     4.38826361404398366E+00,     4.40060929305632934E+00,
     8     4.41280441500754886E+00,     4.42485260777863319E+00,
     9     4.43675736968339510E+00,     4.44852207556574804E+00,
     A     4.46014998254249223E+00,     4.47164423541605544E+00,
     B     4.48300787177969181E+00,     4.49424382683587158E+00,
     C     4.50535493794698269E+00,     4.51634394893599368E+00,
     D     4.52721351415338499E+00,     4.53796620232542800E+00,
     E     4.54860450019776842E+00,     4.55913081598724211E+00/
      DATA C(97), C(98), C(99), C(100)/
     1     4.56954748265390877E+00,     4.57985676100442424E+00,
     2     4.59006084263707730E+00,     4.60016185273808740E+00/
C-----------------------------------------------------------------------
C             COEFFICIENTS OF ASYMPTOTIC EXPANSION
C-----------------------------------------------------------------------
      DATA B(1), B(2), B(3), B(4), B(5), B(6)/
     1     8.33333333333333333E-02,    -8.33333333333333333E-03,
     2     3.96825396825396825E-03,    -4.16666666666666666E-03,
     3     7.57575757575757576E-03,    -2.10927960927960928E-02/
C
      IF (N.GT.100) GO TO 10
      PSIXN = C(N)
      RETURN
   10 CONTINUE
      WDTOL = AMAX1(R1MACH(4),1.0E-18)
      FN = FLOAT(N)
      AX = 1.0E0
      S = -0.5E0/FN
      IF (ABS(S).LE.WDTOL) GO TO 30
      RFN2 = 1.0E0/(FN*FN)
      DO 20 K=1,6
        AX = AX*RFN2
        TRM = -B(K)*AX
        IF (ABS(TRM).LT.WDTOL) GO TO 30
        S = S + TRM
   20 CONTINUE
   30 CONTINUE
      PSIXN = S + ALOG(FN)
      RETURN
      END
c
      REAL FUNCTION R1MACH(I)
C***BEGIN PROLOGUE  R1MACH
C***DATE WRITTEN   790101   (YYMMDD)
C***REVISION DATE  860501   (YYMMDD)
C***CATEGORY NO.  R1
C***KEYWORDS  MACHINE CONSTANTS
C***AUTHOR  FOX, P. A., (BELL LABS)
C           HALL, A. D., (BELL LABS)
C           SCHRYER, N. L., (BELL LABS)
C***PURPOSE  RETURN SINGLE PRECISION MACHINE DEPENDENT CONSTANTS.
C***DESCRIPTION
C
C     R1MACH CAN BE USED TO OBTAIN MACHINE-DEPENDENT PARAMETERS
C     FOR THE LOCAL MACHINE ENVIRONMENT.  IT IS A FUNCTION
C     SUBROUTINE WITH ONE (INPUT) ARGUMENT, AND CAN BE CALLED
C     AS FOLLOWS, FOR EXAMPLE
C
C          A = R1MACH(I)
C
C     WHERE I=1,...,5.  THE (OUTPUT) VALUE OF A ABOVE IS
C     DETERMINED BY THE (INPUT) VALUE OF I.  THE RESULTS FOR
C     VARIOUS VALUES OF I ARE DISCUSSED BELOW.
C
C  SINGLE-PRECISION MACHINE CONSTANTS
C  R1MACH(1) = B**(EMIN-1), THE SMALLEST POSITIVE MAGNITUDE.
C  R1MACH(2) = B**EMAX*(1 - B**(-T)), THE LARGEST MAGNITUDE.
C  R1MACH(3) = B**(-T), THE SMALLEST RELATIVE SPACING.
C  R1MACH(4) = B**(1-T), THE LARGEST RELATIVE SPACING.
C  R1MACH(5) = LOG10(B)
C***REFERENCES  FOX, P.A., HALL, A.D., SCHRYER, N.L, *FRAMEWORK FOR
C                 A PORTABLE LIBRARY*, ACM TRANSACTIONS ON MATHE-
C                 MATICAL SOFTWARE, VOL. 4, NO. 2, JUNE 1978,
C                 PP. 177-188.
C***ROUTINES CALLED  XERROR
C***END PROLOGUE  R1MACH
C
      INTEGER SMALL(2)
      INTEGER LARGE(2)
      INTEGER RIGHT(2)
      INTEGER DIVER(2)
      INTEGER LOG10(2)
C
      REAL RMACH(5)
C
      EQUIVALENCE (RMACH(1),SMALL(1))
      EQUIVALENCE (RMACH(2),LARGE(1))
      EQUIVALENCE (RMACH(3),RIGHT(1))
      EQUIVALENCE (RMACH(4),DIVER(1))
      EQUIVALENCE (RMACH(5),LOG10(1))
c     MACHINE CONSTANTS FOR THE IBM PC - MICROSOFT FORTRAN
C
      DATA SMALL(1) / Z'00800000' /
      DATA LARGE(1) / Z'7F7FFFFF' /
      DATA RIGHT(1) / Z'33800000' /
      DATA DIVER(1) / Z'34000000' /
      DATA LOG10(1) / Z'3E9A209A' /
c
C     MACHINE CONSTANTS FOR THE VAX UNIX F77 COMPILER.
C
c      DATA SMALL(1) /       128 /
c      DATA LARGE(1) /    -32769 /
c      DATA RIGHT(1) /     13440 /
c      DATA DIVER(1) /     13568 /
c      DATA LOG10(1) / 547045274 /
c	 SC/987/
c      DATA RMACH(1) / Z'00800000' /
c      DATA RMACH(2) / Z'7F7FFFFF' /
c      DATA RMACH(3) / Z'33800000' /
c      DATA RMACH(4) / Z'34000000' /
c      DATA RMACH(5) / Z'3E9A209B' /
C
C
C***FIRST EXECUTABLE STATEMENT  R1MACH
      IF (I .LT. 1  .OR.  I .GT. 5)
     1   CALL XERROR ( 'R1MACH -- I OUT OF BOUNDS',25,1,2)
C
      R1MACH = RMACH(I)
      RETURN
      END
C
      SUBROUTINE XERROR(MESS,NMESS,NERR,LEVEL)
C***BEGIN PROLOGUE  XERROR
C***DATE WRITTEN   880401   (YYMMDD)
C***REVISION DATE  880401   (YYMMDD)
C***CATEGORY NO.  R3C
C***KEYWORDS  ERROR,XERROR PACKAGE
C***AUTHOR  AMOS, D. E., (SNLA)
C***PURPOSE  TO PRINT AN ERROR MESSAGE
C***DESCRIPTION
C
C     ABSTRACT
C        XERROR IS A DUMMY SLATEC LIBRARY ROUTINE TO PRINT AN ERROR
C        MESSAGE.  THE CALL LIST IS CONSISTENT WITH THE CORRESPONDING
C        SLATEC LIBRARY SUBROUTINE.
C
C     DESCRIPTION OF PARAMETERS
C      --INPUT--
C        MESSG - THE HOLLERITH MESSAGE TO BE PROCESSED.
C        NMESSG- THE ACTUAL NUMBER OF CHARACTERS IN MESSG.
C        NERR  - THE ERROR NUMBER ASSOCIATED WITH THIS MESSAGE.
C                (A DUMMY VARIABLE NOT USED, BUT NEEDED TO BE COMPATIBLE
C                 WITH THE CORRESPONDING SLATEC ROUTINE)
C        LEVEL - ERROR CATEGORY.
C                (A DUMMY VARIABLE NOT USED, BUT NEEDED TO BE COMPATIBLE
C                 WITH THE CORRESPONDING SLATEC ROUTINE)
C
C***REFERENCES  JONES R.E., KAHANER D.K., 'XERROR, THE SLATEC ERROR-
C                 HANDLING PACKAGE', SAND82-0800, SANDIA LABORATORIES,
C                 1982.
C***ROUTINES CALLED  NONE
C***END PROLOGUE  XERROR
      CHARACTER*(*) MESS
      INTEGER NMESS,NERR,LEVEL,NN,NR,K,I,KMIN,MIN
      IF (NMESS.LE.0) THEN
        PRINT *,' IN XERROR, NMESS IS OUT OF RANGE'
      ELSE
        NN=NMESS/70
        NR=NMESS-70*NN
        IF(NR.NE.0) NN=NN+1
        K=1
        PRINT 900
  900   FORMAT(/)
        DO 10 I=1,NN
          KMIN= MIN(K+69,NMESS)
          PRINT *, MESS(K:KMIN)
          K=K+70
   10   CONTINUE
        RETURN
      END IF
      END
c
      INTEGER FUNCTION I1MACH(I)
C  I/O UNIT NUMBERS.
C    I1MACH( 1) = THE STANDARD INPUT UNIT.
C    I1MACH( 2) = THE STANDARD OUTPUT UNIT.
C    I1MACH( 3) = THE STANDARD PUNCH UNIT.
C    I1MACH( 4) = THE STANDARD ERROR MESSAGE UNIT.
C    I1MACH( 5) = THE NUMBER OF BITS PER INTEGER STORAGE UNIT.
C    I1MACH( 6) = THE NUMBER OF CHARACTERS PER INTEGER STORAGE UNIT.
C  INTEGERS.
C    ASSUME INTEGERS ARE REPRESENTED IN THE S-DIGIT, BASE-A FORM
C
C               SIGN ( X(S-1)*A**(S-1) + ... + X(1)*A + X(0) )
C
C               WHERE 0 .LE. X(I) .LT. A FOR I=0,...,S-1.
C    I1MACH( 7) = A, THE BASE.
C    I1MACH( 8) = S, THE NUMBER OF BASE-A DIGITS.
C    I1MACH( 9) = A**S - 1, THE LARGEST MAGNITUDE.
C
C  FLOATING-POINT NUMBERS.
C    ASSUME FLOATING-POINT NUMBERS ARE REPRESENTED IN THE T-DIGIT,
C    BASE-B FORM
C               SIGN (B**E)*( (X(1)/B) + ... + (X(T)/B**T) )
C
C               WHERE 0 .LE. X(I) .LT. B FOR I=1,...,T,
C               0 .LT. X(1), AND EMIN .LE. E .LE. EMAX.
C    I1MACH(10) = B, THE BASE.
C
C  SINGLE-PRECISION
C    I1MACH(11) = T, THE NUMBER OF BASE-B DIGITS.
C    I1MACH(12) = EMIN, THE SMALLEST EXPONENT E.
C    I1MACH(13) = EMAX, THE LARGEST EXPONENT E.
C
C  DOUBLE-PRECISION
C    I1MACH(14) = T, THE NUMBER OF BASE-B DIGITS.
C    I1MACH(15) = EMIN, THE SMALLEST EXPONENT E.
C    I1MACH(16) = EMAX, THE LARGEST EXPONENT E.
C
      INTEGER IMACH(16),OUTPUT
      EQUIVALENCE (IMACH(4),OUTPUT)
C
C     MACHINE CONSTANTS FOR THE IBM PC - MICROSOFT FORTRAN
C
c      DATA IMACH( 1) /     5 /
c      DATA IMACH( 2) /     6 /
c      DATA IMACH( 3) /     6 /
c      DATA IMACH( 4) /     0 /
c     DATA IMACH( 5) /    32 /
c     DATA IMACH( 6) /     4 /
c      DATA IMACH( 7) /     2 /
c      DATA IMACH( 8) /    31 /
c      DATA IMACH( 9) / 2147483647 /
c      DATA IMACH(10) /     2 /
c      DATA IMACH(11) /    24 /
c      DATA IMACH(12) /  -126 /
c      DATA IMACH(13) /   127 /
c      DATA IMACH(14) /    53 /
c      DATA IMACH(15) / -1022 /
c      DATA IMACH(16) /  1023 /
c
c        SGI
      DATA IMACH( 1) /          5 /
      DATA IMACH( 2) /          6 /
      DATA IMACH( 3) /          6 /
      DATA IMACH( 4) /          6 /
      DATA IMACH( 5) /         32 /
      DATA IMACH( 6) /          4 /
      DATA IMACH( 7) /          2 /
      DATA IMACH( 8) /         31 /
      DATA IMACH( 9) / 2147483647 /
      DATA IMACH(10) /          2 /
      DATA IMACH(11) /         24 /
      DATA IMACH(12) /       -125 /
      DATA IMACH(13) /        128 /
      DATA IMACH(14) /         53 /
      DATA IMACH(15) /      -1021 /
      DATA IMACH(16) /       1024 /
C
C***FIRST EXECUTABLE STATEMENT  I1MACH
      IF (I .LT. 1  .OR.  I .GT. 16) GO TO 10
C
      I1MACH=IMACH(I)
      RETURN
C
   10 CONTINUE
      WRITE(OUTPUT,9000)
9000  FORMAT('1ERROR    1 IN I1MACH - I OUT OF BOUNDS ')
      STOP
      END





C
C     MACHINE CONSTANTS FOR THE AMIGA
C     ABSOFT FORTRAN COMPILER USING THE 68020/68881 COMPILER OPTION
C
C     DATA SMALL(1) / Z'00800000' /
C     DATA LARGE(1) / Z'7F7FFFFF' /
C     DATA RIGHT(1) / Z'33800000' /
C     DATA DIVER(1) / Z'34000000' /
C     DATA LOG10(1) / Z'3E9A209B' /
C
C     MACHINE CONSTANTS FOR THE AMIGA
C     ABSOFT FORTRAN COMPILER USING SOFTWARE FLOATING POINT
C
C     DATA SMALL(1) / Z'00800000' /
C     DATA LARGE(1) / Z'7EFFFFFF' /
C     DATA RIGHT(1) / Z'33800000' /
C     DATA DIVER(1) / Z'34000000' /
C     DATA LOG10(1) / Z'3E9A209B' /
C
C     MACHINE CONSTANTS FOR THE APOLLO
C
C     DATA SMALL(1) / 16#00800000 /
C     DATA LARGE(1) / 16#7FFFFFFF /
C     DATA RIGHT(1) / 16#33800000 /
C     DATA DIVER(1) / 16#34000000 /
C     DATA LOG10(1) / 16#3E9A209B /
C
C     MACHINE CONSTANTS FOR THE BURROUGHS 1700 SYSTEM
C
C     DATA RMACH(1) / Z400800000 /
C     DATA RMACH(2) / Z5FFFFFFFF /
C     DATA RMACH(3) / Z4E9800000 /
C     DATA RMACH(4) / Z4EA800000 /
C     DATA RMACH(5) / Z500E730E8 /
C
C     MACHINE CONSTANTS FOR THE BURROUGHS 5700/6700/7700 SYSTEMS
C
C     DATA RMACH(1) / O1771000000000000 /
C     DATA RMACH(2) / O0777777777777777 /
C     DATA RMACH(3) / O1311000000000000 /
C     DATA RMACH(4) / O1301000000000000 /
C     DATA RMACH(5) / O1157163034761675 /
C
C     MACHINE CONSTANTS FOR THE CDC 170/180 SERIES USING NOS/VE
C
C     DATA RMACH(1) / Z"3001800000000000" /
C     DATA RMACH(2) / Z"4FFEFFFFFFFFFFFE" /
C     DATA RMACH(3) / Z"3FD2800000000000" /
C     DATA RMACH(4) / Z"3FD3800000000000" /
C     DATA RMACH(5) / Z"3FFF9A209A84FBCF" /
C
C     MACHINE CONSTANTS FOR THE CDC 6000/7000 SERIES
C
C     DATA RMACH(1) / 00564000000000000000B /
C     DATA RMACH(2) / 37767777777777777776B /
C     DATA RMACH(3) / 16414000000000000000B /
C     DATA RMACH(4) / 16424000000000000000B /
C     DATA RMACH(5) / 17164642023241175720B /
C
C     MACHINE CONSTANTS FOR THE CELERITY C1260
C
C     DATA SMALL(1) / Z'00800000' /
C     DATA LARGE(1) / Z'7F7FFFFF' /
C     DATA RIGHT(1) / Z'33800000' /
C     DATA DIVER(1) / Z'34000000' /
C     DATA LOG10(1) / Z'3E9A209B' /
C
C     MACHINE CONSTANTS FOR THE CONVEX
C     USING THE -fn COMPILER OPTION
C
C     DATA RMACH(1) / Z'00800000' /
C     DATA RMACH(2) / Z'7FFFFFFF' /
C     DATA RMACH(3) / Z'34800000' /
C     DATA RMACH(4) / Z'35000000' /
C     DATA RMACH(5) / Z'3F9A209B' /
C
C     MACHINE CONSTANTS FOR THE CONVEX
C     USING THE -fi COMPILER OPTION
C
C     DATA RMACH(1) / Z'00800000' /
C     DATA RMACH(2) / Z'7F7FFFFF' /
C     DATA RMACH(3) / Z'33800000' /
C     DATA RMACH(4) / Z'34000000' /
C     DATA RMACH(5) / Z'3E9A209B' /
C
C     MACHINE CONSTANTS FOR THE CONVEX
C     USING THE -p8 OR -pd8 COMPILER OPTION
C
C     DATA RMACH(1) / Z'0010000000000000' /
C     DATA RMACH(2) / Z'7FFFFFFFFFFFFFFF' /
C     DATA RMACH(3) / Z'3CC0000000000000' /
C     DATA RMACH(4) / Z'3CD0000000000000' /
C     DATA RMACH(5) / Z'3FF34413509F79FF' /
C
C     MACHINE CONSTANTS FOR THE CRAY
C
C     DATA RMACH(1) / 200034000000000000000B /
C     DATA RMACH(2) / 577767777777777777776B /
C     DATA RMACH(3) / 377224000000000000000B /
C     DATA RMACH(4) / 377234000000000000000B /
C     DATA RMACH(5) / 377774642023241175720B /
C
C     MACHINE CONSTANTS FOR THE DATA GENERAL ECLIPSE S/200
C     NOTE - IT MAY BE APPROPRIATE TO INCLUDE THE FOLLOWING CARD -
C     STATIC RMACH(5)
C
C     DATA SMALL /    20K,       0 /
C     DATA LARGE / 77777K, 177777K /
C     DATA RIGHT / 35420K,       0 /
C     DATA DIVER / 36020K,       0 /
C     DATA LOG10 / 40423K,  42023K /
C
C     MACHINE CONSTANTS FOR THE DEC ALPHA
C     USING G_FLOAT
C
C     DATA RMACH(1) / '00000080'X /
C     DATA RMACH(2) / 'FFFF7FFF'X /
C     DATA RMACH(3) / '00003480'X /
C     DATA RMACH(4) / '00003500'X /
C     DATA RMACH(5) / '209B3F9A'X /
C
C     MACHINE CONSTANTS FOR THE DEC ALPHA
C     USING IEEE_FLOAT
C
C     DATA RMACH(1) / '00800000'X /
C     DATA RMACH(2) / '7F7FFFFF'X /
C     DATA RMACH(3) / '33800000'X /
C     DATA RMACH(4) / '34000000'X /
C     DATA RMACH(5) / '3E9A209B'X /
C
C     MACHINE CONSTANTS FOR THE DEC RISC
C
C     DATA RMACH(1) / Z'00800000' /
C     DATA RMACH(2) / Z'7F7FFFFF' /
C     DATA RMACH(3) / Z'33800000' /
C     DATA RMACH(4) / Z'34000000' /
C     DATA RMACH(5) / Z'3E9A209B' /
C
C     MACHINE CONSTANTS FOR THE DEC VAX
C     (EXPRESSED IN INTEGER AND HEXADECIMAL)
C     THE HEX FORMAT BELOW MAY NOT BE SUITABLE FOR UNIX SYSTEMS
C     THE INTEGER FORMAT SHOULD BE OK FOR UNIX SYSTEMS
C
C     DATA SMALL(1) /       128 /
C     DATA LARGE(1) /    -32769 /
C     DATA RIGHT(1) /     13440 /
C     DATA DIVER(1) /     13568 /
C     DATA LOG10(1) / 547045274 /
C
C     DATA SMALL(1) / Z00000080 /
C     DATA LARGE(1) / ZFFFF7FFF /
C     DATA RIGHT(1) / Z00003480 /
C     DATA DIVER(1) / Z00003500 /
C     DATA LOG10(1) / Z209B3F9A /
C
C     MACHINE CONSTANTS FOR THE ELXSI 6400
C     (ASSUMING REAL*4 IS THE DEFAULT REAL)
C
C     DATA SMALL(1) / '00800000'X /
C     DATA LARGE(1) / '7F7FFFFF'X /
C     DATA RIGHT(1) / '33800000'X /
C     DATA DIVER(1) / '34000000'X /
C     DATA LOG10(1) / '3E9A209B'X /
C
C     MACHINE CONSTANTS FOR THE HARRIS 220
C
C     DATA SMALL(1), SMALL(2) / '20000000, '00000201 /
C     DATA LARGE(1), LARGE(2) / '37777777, '00000177 /
C     DATA RIGHT(1), RIGHT(2) / '20000000, '00000352 /
C     DATA DIVER(1), DIVER(2) / '20000000, '00000353 /
C     DATA LOG10(1), LOG10(2) / '23210115, '00000377 /
C
C     MACHINE CONSTANTS FOR THE HONEYWELL 600/6000 SERIES
C
C     DATA RMACH(1) / O402400000000 /
C     DATA RMACH(2) / O376777777777 /
C     DATA RMACH(3) / O714400000000 /
C     DATA RMACH(4) / O716400000000 /
C     DATA RMACH(5) / O776464202324 /
C
C     MACHINE CONSTANTS FOR THE HP 730
C
C     DATA RMACH(1) / Z'00800000' /
C     DATA RMACH(2) / Z'7F7FFFFF' /
C     DATA RMACH(3) / Z'33800000' /
C     DATA RMACH(4) / Z'34000000' /
C     DATA RMACH(5) / Z'3E9A209B' /
C
C     MACHINE CONSTANTS FOR THE HP 2100
C     3 WORD DOUBLE PRECISION WITH FTN4
C
C     DATA SMALL(1), SMALL(2) / 40000B,       1 /
C     DATA LARGE(1), LARGE(2) / 77777B, 177776B /
C     DATA RIGHT(1), RIGHT(2) / 40000B,    325B /
C     DATA DIVER(1), DIVER(2) / 40000B,    327B /
C     DATA LOG10(1), LOG10(2) / 46420B,  46777B /
C
C     MACHINE CONSTANTS FOR THE HP 2100
C     4 WORD DOUBLE PRECISION WITH FTN4
C
C     DATA SMALL(1), SMALL(2) / 40000B,       1 /
C     DATA LARGE(1), LARGE(2) / 77777B, 177776B /
C     DATA RIGHT(1), RIGHT(2) / 40000B,    325B /
C     DATA DIVER(1), DIVER(2) / 40000B,    327B /
C     DATA LOG10(1), LOG10(2) / 46420B,  46777B /
C
C     MACHINE CONSTANTS FOR THE HP 9000
C
C     DATA SMALL(1) / 00004000000B /
C     DATA LARGE(1) / 17677777777B /
C     DATA RIGHT(1) / 06340000000B /
C     DATA DIVER(1) / 06400000000B /
C     DATA LOG10(1) / 07646420233B /
C
C     MACHINE CONSTANTS FOR THE IBM 360/370 SERIES,
C     THE XEROX SIGMA 5/7/9, THE SEL SYSTEMS 85/86  AND
C     THE PERKIN ELMER (INTERDATA) 7/32.
C
C     DATA RMACH(1) / Z00100000 /
C     DATA RMACH(2) / Z7FFFFFFF /
C     DATA RMACH(3) / Z3B100000 /
C     DATA RMACH(4) / Z3C100000 /
C     DATA RMACH(5) / Z41134413 /
C
C     MACHINE CONSTANTS FOR THE IBM PC
C
C     DATA SMALL(1) / 1.18E-38      /
C     DATA LARGE(1) / 3.40E+38      /
C     DATA RIGHT(1) / 0.595E-07     /
C     DATA DIVER(1) / 1.19E-07      /
C     DATA LOG10(1) / 0.30102999566 /
C
C     MACHINE CONSTANTS FOR THE IBM RS 6000
C
C     DATA RMACH(1) / Z'00800000' /
C     DATA RMACH(2) / Z'7F7FFFFF' /
C     DATA RMACH(3) / Z'33800000' /
C     DATA RMACH(4) / Z'34000000' /
C     DATA RMACH(5) / Z'3E9A209B' /
C
C     MACHINE CONSTANTS FOR THE INTEL i860
C
C     DATA RMACH(1) / Z'00800000' /
C     DATA RMACH(2) / Z'7F7FFFFF' /
C     DATA RMACH(3) / Z'33800000' /
C     DATA RMACH(4) / Z'34000000' /
C     DATA RMACH(5) / Z'3E9A209B' /
C
C     MACHINE CONSTANTS FOR THE PDP-10 (KA OR KI PROCESSOR)
C
C     DATA RMACH(1) / "000400000000 /
C     DATA RMACH(2) / "377777777777 /
C     DATA RMACH(3) / "146400000000 /
C     DATA RMACH(4) / "147400000000 /
C     DATA RMACH(5) / "177464202324 /
C
C     MACHINE CONSTANTS FOR PDP-11 FORTRAN SUPPORTING
C     32-BIT INTEGERS (EXPRESSED IN INTEGER AND OCTAL).
C
C     DATA SMALL(1) /    8388608 /
C     DATA LARGE(1) / 2147483647 /
C     DATA RIGHT(1) /  880803840 /
C     DATA DIVER(1) /  889192448 /
C     DATA LOG10(1) / 1067065499 /
C
C     DATA RMACH(1) / O00040000000 /
C     DATA RMACH(2) / O17777777777 /
C     DATA RMACH(3) / O06440000000 /
C     DATA RMACH(4) / O06500000000 /
C     DATA RMACH(5) / O07746420233 /
C
C     MACHINE CONSTANTS FOR PDP-11 FORTRAN SUPPORTING
C     16-BIT INTEGERS  (EXPRESSED IN INTEGER AND OCTAL).
C
C     DATA SMALL(1), SMALL(2) /   128,     0 /
C     DATA LARGE(1), LARGE(2) / 32767,    -1 /
C     DATA RIGHT(1), RIGHT(2) / 13440,     0 /
C     DATA DIVER(1), DIVER(2) / 13568,     0 /
C     DATA LOG10(1), LOG10(2) / 16282,  8347 /
C
C     DATA SMALL(1), SMALL(2) / O000200, O000000 /
C     DATA LARGE(1), LARGE(2) / O077777, O177777 /
C     DATA RIGHT(1), RIGHT(2) / O032200, O000000 /
C     DATA DIVER(1), DIVER(2) / O032400, O000000 /
C     DATA LOG10(1), LOG10(2) / O037632, O020233 /
C
C     MACHINE CONSTANTS FOR THE SILICON GRAPHICS
C
C     DATA RMACH(1) / Z'00800000' /
C     DATA RMACH(2) / Z'7F7FFFFF' /
C     DATA RMACH(3) / Z'33800000' /
C     DATA RMACH(4) / Z'34000000' /
C     DATA RMACH(5) / Z'3E9A209B' /
C
C     MACHINE CONSTANTS FOR THE SUN
C
C     DATA RMACH(1) / Z'00800000' /
C     DATA RMACH(2) / Z'7F7FFFFF' /
C     DATA RMACH(3) / Z'33800000' /
C     DATA RMACH(4) / Z'34000000' /
C     DATA RMACH(5) / Z'3E9A209B' /
C
C     MACHINE CONSTANTS FOR THE SUN
C     USING THE -r8 COMPILER OPTION
C
C     DATA RMACH(1) / Z'0010000000000000' /
C     DATA RMACH(2) / Z'7FEFFFFFFFFFFFFF' /
C     DATA RMACH(3) / Z'3CA0000000000000' /
C     DATA RMACH(4) / Z'3CB0000000000000' /
C     DATA RMACH(5) / Z'3FD34413509F79FF' /
C
C     MACHINE CONSTANTS FOR THE UNIVAC 1100 SERIES
C
C     DATA RMACH(1) / O000400000000 /
C     DATA RMACH(2) / O377777777777 /
C     DATA RMACH(3) / O146400000000 /
C     DATA RMACH(4) / O147400000000 /
C     DATA RMACH(5) / O177464202324 /
C
C     MACHINE CONSTANTS FOR THE Z80 MICROPROCESSOR
C
C     DATA SMALL(1), SMALL(2) /     0,    256/
C     DATA LARGE(1), LARGE(2) /    -1,   -129/
C     DATA RIGHT(1), RIGHT(2) /     0,  26880/
C     DATA DIVER(1), DIVER(2) /     0,  27136/
C     DATA LOG10(1), LOG10(2) /  8347,  32538/

c
c
c
C
C     MACHINE CONSTANTS FOR THE AMIGA
C     ABSOFT COMPILER
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          5 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -126 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1022 /
C     DATA IMACH(16) /       1023 /
C
C     MACHINE CONSTANTS FOR THE APOLLO
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          6 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -125 /
C     DATA IMACH(13) /        129 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1021 /
C     DATA IMACH(16) /       1025 /
C
C     MACHINE CONSTANTS FOR THE BURROUGHS 1700 SYSTEM
C
C     DATA IMACH( 1) /          7 /
C     DATA IMACH( 2) /          2 /
C     DATA IMACH( 3) /          2 /
C     DATA IMACH( 4) /          2 /
C     DATA IMACH( 5) /         36 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         33 /
C     DATA IMACH( 9) / Z1FFFFFFFF /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -256 /
C     DATA IMACH(13) /        255 /
C     DATA IMACH(14) /         60 /
C     DATA IMACH(15) /       -256 /
C     DATA IMACH(16) /        255 /
C
C     MACHINE CONSTANTS FOR THE BURROUGHS 5700 SYSTEM
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          7 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         48 /
C     DATA IMACH( 6) /          6 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         39 /
C     DATA IMACH( 9) / O0007777777777777 /
C     DATA IMACH(10) /          8 /
C     DATA IMACH(11) /         13 /
C     DATA IMACH(12) /        -50 /
C     DATA IMACH(13) /         76 /
C     DATA IMACH(14) /         26 /
C     DATA IMACH(15) /        -50 /
C     DATA IMACH(16) /         76 /
C
C     MACHINE CONSTANTS FOR THE BURROUGHS 6700/7700 SYSTEMS
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          7 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         48 /
C     DATA IMACH( 6) /          6 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         39 /
C     DATA IMACH( 9) / O0007777777777777 /
C     DATA IMACH(10) /          8 /
C     DATA IMACH(11) /         13 /
C     DATA IMACH(12) /        -50 /
C     DATA IMACH(13) /         76 /
C     DATA IMACH(14) /         26 /
C     DATA IMACH(15) /     -32754 /
C     DATA IMACH(16) /      32780 /
C
C     MACHINE CONSTANTS FOR THE CDC 170/180 SERIES USING NOS/VE
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          7 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         64 /
C     DATA IMACH( 6) /          8 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         63 /
C     DATA IMACH( 9) / 9223372036854775807 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         47 /
C     DATA IMACH(12) /      -4095 /
C     DATA IMACH(13) /       4094 /
C     DATA IMACH(14) /         94 /
C     DATA IMACH(15) /      -4095 /
C     DATA IMACH(16) /       4094 /
C
C     MACHINE CONSTANTS FOR THE CDC 6000/7000 SERIES
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          7 /
C     DATA IMACH( 4) /    6LOUTPUT/
C     DATA IMACH( 5) /         60 /
C     DATA IMACH( 6) /         10 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         48 /
C     DATA IMACH( 9) / 00007777777777777777B /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         47 /
C     DATA IMACH(12) /       -929 /
C     DATA IMACH(13) /       1070 /
C     DATA IMACH(14) /         94 /
C     DATA IMACH(15) /       -929 /
C     DATA IMACH(16) /       1069 /
C
C     MACHINE CONSTANTS FOR THE CELERITY C1260
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          6 /
C     DATA IMACH( 4) /          0 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / Z'7FFFFFFF' /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -126 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1022 /
C     DATA IMACH(16) /       1023 /
C
C     MACHINE CONSTANTS FOR THE CONVEX
C     USING THE -fn COMPILER OPTION
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          7 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -127 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1023 /
C     DATA IMACH(16) /       1023 /
C
C     MACHINE CONSTANTS FOR THE CONVEX
C     USING THE -fi COMPILER OPTION
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          7 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -125 /
C     DATA IMACH(13) /        128 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1021 /
C     DATA IMACH(16) /       1024 /
C
C     MACHINE CONSTANTS FOR THE CONVEX
C     USING THE -p8 COMPILER OPTION
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          7 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         64 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         63 /
C     DATA IMACH( 9) / 9223372036854775807 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         53 /
C     DATA IMACH(12) /      -1023 /
C     DATA IMACH(13) /       1023 /
C     DATA IMACH(14) /        113 /
C     DATA IMACH(15) /     -16383 /
C     DATA IMACH(16) /      16383 /
C
C     MACHINE CONSTANTS FOR THE CONVEX
C     USING THE -pd8 COMPILER OPTION
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          7 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         64 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         63 /
C     DATA IMACH( 9) / 9223372036854775807 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         53 /
C     DATA IMACH(12) /      -1023 /
C     DATA IMACH(13) /       1023 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1023 /
C     DATA IMACH(16) /       1023 /
C
C     MACHINE CONSTANTS FOR THE CRAY
C     USING THE 46 BIT INTEGER COMPILER OPTION
C
C     DATA IMACH( 1) /        100 /
C     DATA IMACH( 2) /        101 /
C     DATA IMACH( 3) /        102 /
C     DATA IMACH( 4) /        101 /
C     DATA IMACH( 5) /         64 /
C     DATA IMACH( 6) /          8 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         46 /
C     DATA IMACH( 9) / 1777777777777777B /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         47 /
C     DATA IMACH(12) /      -8189 /
C     DATA IMACH(13) /       8190 /
C     DATA IMACH(14) /         94 /
C     DATA IMACH(15) /      -8099 /
C     DATA IMACH(16) /       8190 /
C
C     MACHINE CONSTANTS FOR THE CRAY
C     USING THE 64 BIT INTEGER COMPILER OPTION
C
C     DATA IMACH( 1) /        100 /
C     DATA IMACH( 2) /        101 /
C     DATA IMACH( 3) /        102 /
C     DATA IMACH( 4) /        101 /
C     DATA IMACH( 5) /         64 /
C     DATA IMACH( 6) /          8 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         63 /
C     DATA IMACH( 9) / 777777777777777777777B /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         47 /
C     DATA IMACH(12) /      -8189 /
C     DATA IMACH(13) /       8190 /
C     DATA IMACH(14) /         94 /
C     DATA IMACH(15) /      -8099 /
C     DATA IMACH(16) /       8190 /
C
C     MACHINE CONSTANTS FOR THE DATA GENERAL ECLIPSE S/200
C
C     DATA IMACH( 1) /         11 /
C     DATA IMACH( 2) /         12 /
C     DATA IMACH( 3) /          8 /
C     DATA IMACH( 4) /         10 /
C     DATA IMACH( 5) /         16 /
C     DATA IMACH( 6) /          2 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         15 /
C     DATA IMACH( 9) /      32767 /
C     DATA IMACH(10) /         16 /
C     DATA IMACH(11) /          6 /
C     DATA IMACH(12) /        -64 /
C     DATA IMACH(13) /         63 /
C     DATA IMACH(14) /         14 /
C     DATA IMACH(15) /        -64 /
C     DATA IMACH(16) /         63 /
C
C     MACHINE CONSTANTS FOR THE DEC ALPHA
C     USING G_FLOAT
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          5 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -127 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1023 /
C     DATA IMACH(16) /       1023 /
C
C     MACHINE CONSTANTS FOR THE DEC ALPHA
C     USING IEEE_FLOAT
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          6 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -125 /
C     DATA IMACH(13) /        128 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1021 /
C     DATA IMACH(16) /       1024 /
C
C     MACHINE CONSTANTS FOR THE DEC RISC
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          6 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -125 /
C     DATA IMACH(13) /        128 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1021 /
C     DATA IMACH(16) /       1024 /
C
C     MACHINE CONSTANTS FOR THE DEC VAX
C     USING D_FLOATING
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          5 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -127 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         56 /
C     DATA IMACH(15) /       -127 /
C     DATA IMACH(16) /        127 /
C
C     MACHINE CONSTANTS FOR THE DEC VAX
C     USING G_FLOATING
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          5 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -127 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1023 /
C     DATA IMACH(16) /       1023 /
C
C     MACHINE CONSTANTS FOR THE ELXSI 6400
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          6 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         32 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -126 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1022 /
C     DATA IMACH(16) /       1023 /
C
C     MACHINE CONSTANTS FOR THE HARRIS 220
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          0 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         24 /
C     DATA IMACH( 6) /          3 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         23 /
C     DATA IMACH( 9) /    8388607 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         23 /
C     DATA IMACH(12) /       -127 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         38 /
C     DATA IMACH(15) /       -127 /
C     DATA IMACH(16) /        127 /
C
C     MACHINE CONSTANTS FOR THE HONEYWELL 600/6000 SERIES
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /         43 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         36 /
C     DATA IMACH( 6) /          6 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         35 /
C     DATA IMACH( 9) / O377777777777 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         27 /
C     DATA IMACH(12) /       -127 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         63 /
C     DATA IMACH(15) /       -127 /
C     DATA IMACH(16) /        127 /
C
C     MACHINE CONSTANTS FOR THE HP 730
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          6 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -125 /
C     DATA IMACH(13) /        128 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1021 /
C     DATA IMACH(16) /       1024 /
C
C     MACHINE CONSTANTS FOR THE HP 2100
C     3 WORD DOUBLE PRECISION OPTION WITH FTN4
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          4 /
C     DATA IMACH( 4) /          1 /
C     DATA IMACH( 5) /         16 /
C     DATA IMACH( 6) /          2 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         15 /
C     DATA IMACH( 9) /      32767 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         23 /
C     DATA IMACH(12) /       -128 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         39 /
C     DATA IMACH(15) /       -128 /
C     DATA IMACH(16) /        127 /
C
C     MACHINE CONSTANTS FOR THE HP 2100
C     4 WORD DOUBLE PRECISION OPTION WITH FTN4
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          4 /
C     DATA IMACH( 4) /          1 /
C     DATA IMACH( 5) /         16 /
C     DATA IMACH( 6) /          2 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         15 /
C     DATA IMACH( 9) /      32767 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         23 /
C     DATA IMACH(12) /       -128 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         55 /
C     DATA IMACH(15) /       -128 /
C     DATA IMACH(16) /        127 /
C
C     MACHINE CONSTANTS FOR THE HP 9000
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          6 /
C     DATA IMACH( 4) /          7 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         32 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -126 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1015 /
C     DATA IMACH(16) /       1017 /
C
C     MACHINE CONSTANTS FOR THE IBM 360/370 SERIES,
C     THE XEROX SIGMA 5/7/9, THE SEL SYSTEMS 85/86, AND
C     THE PERKIN ELMER (INTERDATA) 7/32.
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          7 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) /  Z7FFFFFFF /
C     DATA IMACH(10) /         16 /
C     DATA IMACH(11) /          6 /
C     DATA IMACH(12) /        -64 /
C     DATA IMACH(13) /         63 /
C     DATA IMACH(14) /         14 /
C     DATA IMACH(15) /        -64 /
C     DATA IMACH(16) /         63 /
C
C     MACHINE CONSTANTS FOR THE IBM PC
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          0 /
C     DATA IMACH( 4) /          0 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -125 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1021 /
C     DATA IMACH(16) /       1023 /
C
C     MACHINE CONSTANTS FOR THE IBM RS 6000
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          6 /
C     DATA IMACH( 4) /          0 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -125 /
C     DATA IMACH(13) /        128 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1021 /
C     DATA IMACH(16) /       1024 /
C
C     MACHINE CONSTANTS FOR THE INTEL i860
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          6 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -125 /
C     DATA IMACH(13) /        128 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1021 /
C     DATA IMACH(16) /       1024 /
C
C     MACHINE CONSTANTS FOR THE PDP-10 (KA PROCESSOR)
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          5 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         36 /
C     DATA IMACH( 6) /          5 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         35 /
C     DATA IMACH( 9) / "377777777777 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         27 /
C     DATA IMACH(12) /       -128 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         54 /
C     DATA IMACH(15) /       -101 /
C     DATA IMACH(16) /        127 /
C
C     MACHINE CONSTANTS FOR THE PDP-10 (KI PROCESSOR)
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          5 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         36 /
C     DATA IMACH( 6) /          5 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         35 /
C     DATA IMACH( 9) / "377777777777 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         27 /
C     DATA IMACH(12) /       -128 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         62 /
C     DATA IMACH(15) /       -128 /
C     DATA IMACH(16) /        127 /
C
C     MACHINE CONSTANTS FOR PDP-11 FORTRAN SUPPORTING
C     32-BIT INTEGER ARITHMETIC.
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          5 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -127 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         56 /
C     DATA IMACH(15) /       -127 /
C     DATA IMACH(16) /        127 /
C
C     MACHINE CONSTANTS FOR PDP-11 FORTRAN SUPPORTING
C     16-BIT INTEGER ARITHMETIC.
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          5 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         16 /
C     DATA IMACH( 6) /          2 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         15 /
C     DATA IMACH( 9) /      32767 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -127 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         56 /
C     DATA IMACH(15) /       -127 /
C     DATA IMACH(16) /        127 /
C
C     MACHINE CONSTANTS FOR THE SILICON GRAPHICS
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          6 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -125 /
C     DATA IMACH(13) /        128 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1021 /
C     DATA IMACH(16) /       1024 /
C
C     MACHINE CONSTANTS FOR THE SUN
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          6 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -125 /
C     DATA IMACH(13) /        128 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1021 /
C     DATA IMACH(16) /       1024 /
C
C     MACHINE CONSTANTS FOR THE SUN
C     USING THE -r8 COMPILER OPTION
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          6 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         53 /
C     DATA IMACH(12) /      -1021 /
C     DATA IMACH(13) /       1024 /
C     DATA IMACH(14) /        113 /
C     DATA IMACH(15) /     -16381 /
C     DATA IMACH(16) /      16384 /
C
C     MACHINE CONSTANTS FOR THE UNIVAC 1100 SERIES FTN COMPILER
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          1 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         36 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         35 /
C     DATA IMACH( 9) / O377777777777 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         27 /
C     DATA IMACH(12) /       -128 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         60 /
C     DATA IMACH(15) /      -1024 /
C     DATA IMACH(16) /       1023 /
C
C     MACHINE CONSTANTS FOR THE Z80 MICROPROCESSOR
C
C     DATA IMACH( 1) /          1 /
C     DATA IMACH( 2) /          1 /
C     DATA IMACH( 3) /          0 /
C     DATA IMACH( 4) /          1 /
C     DATA IMACH( 5) /         16 /
C     DATA IMACH( 6) /          2 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         15 /
C     DATA IMACH( 9) /      32767 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -127 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         56 /
C     DATA IMACH(15) /       -127 /
C     DATA IMACH(16) /        127 /
C


