c
c**********************************************************************************
c
C     RADIX2 FFT - THE NO. OF GRID DIVISIONS (NPAR) MUST BE A POWER OF TWO.
C     ---------------------------------------------------------------------
C     UNIX systems users must compile f77 with -static to zero work arrays
C     f77 -O3 -sopt -noisam -mips2 -share_all -align32 -static FFT.f -o FFT
C     ---------------------------------------------------------------------
      SUBROUTINE FOURIER(JDS,IPH,MPAR,MPAX,ISECT,IHORZ,IVERT,ISLICE,RS)      
      INCLUDE 'param.inc'
      PARAMETER (NPAR=128,NP=NPAR-1,MH=60)
      BYTE NH(0:MH,-MH:MH),HH,HK,HL,NT(96,9)
      REAL*8 ARG,PI2,PX
      INTEGER*2 JH,JK,JL,IH,IK,IL,NPH,NM(0:NP),MN(0:NP),IPH,JDS,ISLICE
      DIMENSION R(0:NP,0:NP,0:NP),TX(16,3),RS(0:NP,0:NP)
      COMPLEX F(0:MH,-MH:MH,-MH:MH),CX(0:NP),FX(0:NP),P(0:NP,0:NP),CXL
      DATA MAXH,MAXK,MAXL,MINK,MINL,PX/5*0,-1./
      INTEGER, Pointer::  IREFS(:,:),ICX(:,:)
      REAL, POINTER:: REFS(:,:,:),FF(:,:)
      REAL, POINTER:: COBS(:,:),SOMEGA(:,:),VAR(:,:)
      COMMON/REFLS/IREFS,REFS,FF,ICX
      COMMON/RBRAGG/COBS,SOMEGA,VAR
      COMMON/G1/THMIN(MAXDS),STEP(MAXDS),THMAX(MAXDS),U(MAXDS),
     &  V(MAXDS),W(MAXDS),LAMDA(MAXDS,2),TMV(MAXDS),CTHM(MAXDS),
     &  RLIM,SBX,WDT(MAXDS),UU(MAXDS),VV(MAXDS),WW(MAXDS),FFLIM(MAXDS),
     &  IABSCOR(MAXDS)
      REAL,POINTER:: PHASE(:)
      COMMON/FOUR/PHASE
      COMMON/PARAMS/GLB(MAXGP),AGLB(MAXGP),LGLB(MAXGP),PAR(NUPH,MAXAP),
     *APAR(NUPH,MAXAP),LPAR(NUPH,MAXAP),XL(NATS,11),LP(NATS,11),
     *A(NATS,11),PTR(MAXDS,NATS),RELAX(4),RATIO(MAXDS,2),IPTYPE(NUPH)
      COMMON/RTMTX/IVEC(NUPH,192),MLT(NUPH),ICET(NUPH),IPHMULT(NUPH)
      DIMENSION SM(3,3)
	INTEGER IV                        
C
cc      OPEN(UNIT=1,FILE='fft.dat',STATUS='old',FORM='formatted')
cc      READ(1,*)MPAR,MPAX,ISECT,IHORZ,IVERT
C
C     Example of the fft.dat control parameter file.
C     
C     A typical P212121 map.  MPAR must be a power of two.  The map consists
C     of 32 (MPAX) 128x128 sections normal to the cell's A-axis (ISECT=1).
C     NSYM = 4 equivalent positions for space group P212121 as indicated.
C     Positions related by lattice centering and inversion are not included.
C     The sorting order on last two directions IHORZ & IVERT is immaterial
C     but must be some permutation order of the numbers 1, 2 and 3.
C  
C  128  32   1   2   3
C  4
C  0.0000      1    0    0  0.0000      0    1    0  0.0000      0    0    1
C  0.5000     -1    0    0  0.0000      0   -1    0  0.5000      0    0    1
C  0.0000     -1    0    0  0.5000      0    1    0  0.5000      0    0   -1
C  0.5000      1    0    0  0.5000      0   -1    0  0.0000      0    0   -1
C 
C     Read the equivalent positions as given in International Table Vol I.
C         MPAR = X x Y dimension
c         MPAX = number of Z sections
C         ISECT: 1=A, 2=B, 3=C
C         IHORZ,IVERT = other number from ISECT
c         NSYM = Number of symmetery operators
C         TX = translation vector
C         HH..LL = rotation matrix elements
C
      NSYM = MLT(IPH)
      DO I=1,NSYM
C        READ(1,17)TX(I,1),HH,HK,HL,TX(I,2),KH,KK,KL,TX(I,3),LH,LK,LL
        DO J=1,3
	     TX(I,J) = FLOAT(MOD(IVEC(IPH,I)/32**(3-J),32)-16)/12.0
        ENDDO
        DO J=1,3
           IV=IVEC(IPH,I)/32768/32**(3-J)
           IV=MOD(IV,32)
           SM(J,1)=IV/9-1                                                    !SM = symmetry matrix
           SM(J,2)=MOD(IV/3,3)-1
           SM(J,3)=MOD(IV,3)-1
	  ENDDO
        HH = SM(1,1)	
        HK = SM(2,1)	
        HL = SM(3,1)	
        KH = SM(1,2)	
        KK = SM(2,2)	
        KL = SM(3,2)	
        LH = SM(1,3)	
        LK = SM(2,3)	
        LL = SM(3,3)	
        IDET = HH*KK*LL+HK*KL*LH+KH*LK*HL-LH*KK*HL-KH*HK*LL-HH*LK*KL
        NT(I,1) = (KK*LL-LK*KL)/IDET
        NT(I,2) =-(KH*LL-LH*KL)/IDET
        NT(I,3) = (KH*LK-KK*LH)/IDET
        NT(I,4) =-(HK*LL-HL*LK)/IDET
        NT(I,5) = (HH*LL-LH*HL)/IDET
        NT(I,6) =-(HH*LK-LH*HK)/IDET
        NT(I,7) = (HK*KL-KK*HL)/IDET
        NT(I,8) =-(HH*KL-HL*KH)/IDET
        NT(I,9) = (HH*KK-HK*KH)/IDET
      ENDDO
      CLOSE(1)
      MPA=MPAR-1
      PI2=2.0*DACOS(PX)
      PX=PI2/MPAR
C     initialize exp(-2pi*x/MPAR)
      DO 20 I=0,MPA
      ARG=-I*PX
   20 CX(I)=DCMPLX(DCOS(ARG),DSIN(ARG))
C     set up arrays for FFT bit inversion
      NM(0)=0
      MM=1
      NX = ALOG(FLOAT(MPAR))/ALOG(2.0) +.1
      DO 23 I=1,NX
      DO 24 J=0,MM-1
      NM(J)=2*NM(J)
   24 NM(J+MM) = NM(J)+1
   23 MM=MM+MM
C     read reflection data,IH,IK,IL,Fobs and NPH = 1000*phase in radians
C     Note that IH,IK,IL and NPH are integer*2 variables.
c      OPEN(UNIT=1,FILE='fourr.tmp',STATUS='old',FORM='unformatted')
      DO 26 I=1,ICX(JDS,IPH)
C         READ(1,END=27)IH,IK,IL,jh,jk,FO,ax,ax,NPH
         IF(IPH.NE.IREFS(JDS,I)/256/256/256/4)GOTO 26
         IL=MOD(IREFS(JDS,I),256)-128
         IK=MOD(IREFS(JDS,I)/256,256)-128
         IH=MOD(IREFS(JDS,I)/256/256,256)-128
c         SH = IH*TX(J,1) + IK*TX(J,2) + IL*TX(J,3)
         FO=COBS(JDS,I)*STEP(JDS)/(REFS(JDS,I,3)*PAR(IPH,1)*
     *      GLB(14+(JDS-1)*MAXIGL))
         PH=PHASE(I) + PI2*MOD(SH,1.0)
c         PH=PHASE(I) + PI2*MOD(SH,1.0)
         DO 28 J=1,NSYM
            JH = IH*NT(J,1) + IK*NT(J,2) + IL*NT(J,3)
            JK = IH*NT(J,4) + IK*NT(J,5) + IL*NT(J,6)
            JL = IH*NT(J,7) + IK*NT(J,8) + IL*NT(J,9)
            SH = IH*TX(J,1) + IK*TX(J,2) + IL*TX(J,3)
      write(*,*) jh,jk,jl
            CALL SWAP(JH,JK,JL,PH,IHORZ,IVERT,ISECT)
            NH(JH,JK)=1
            MAXH=MAX(JH,MAXH)
            MAXK=MAX(JK,MAXK)
            MAXL=MAX(JL,MAXL)
            MINK=MIN(JK,MINK)
            MINL=MIN(JL,MINL)
   28    F(JH,JK,JL) = FO*CMPLX(COS(PH),SIN(PH))
   26 CONTINUE
      write(*,*) nsym
      t0=secnds(0.0)
C     calculate FOURIER
      DO 1 IH=0,MAXH
      DO 2 IZ=0,MPA
      DO 2 IY=0,MPA
    2 P(IY,IZ)=0.0
      DO 3 IK = MINK,MAXK
      IF(NH(IH,IK).EQ.0) GOTO 3
      DO 4 IZ=0,MPA
    4 FX(IZ)=0.
      DO 5 IL = MINL,MAXL
    5 FX(NM(IL.AND.MPA))=F(IH,IK,IL)
      CALL FFT(MPAR,FX,CX,NX)
      JK=IK.AND.MPA
      DO 6 IZ=0,MPA
    6 P(JK,IZ) = FX(IZ)
    3 CONTINUE
      DO 7 IZ=0,MPA
      DO 8 IK=0,MPA
    8 FX(IK)=0.
      DO 9 IK = MINK,MAXK
      JK=IK.AND.MPA
    9 FX(NM(JK))=P(JK,IZ)
      CALL FFT(MPAR,FX,CX,NX)
      DO 10 IY=0,MPA
   10 P(IY,IZ)=FX(IY)
    7 CONTINUE
      DO 11 IX=0,MPAX
      CXL = CX((IH*IX).AND.MPA)
      DO 11 IZ=0,MPA
      DO 11 IY=0,MPA
   11 R(IY,IZ,IX) = R(IY,IZ,IX) + P(IY,IZ)*CXL
    1 CONTINUE
      t1=secnds(t0)
C      write(*,*)t1
      DO J=0,MPA
	  DO K=0,MPA
	    RS(J,K) = R(J,K,ISLICE)
	  ENDDO
	ENDDO
C     Write Fourier map to file or call peak pick or graphics routine
C     DO 12 I=0,MPAX
   12 WRITE(1,*) ((R(J,K,0),J=0,MPA),K=0,MPA)
      RETURN
      END
C
      SUBROUTINE FFT(N,F,CX,NX)
C     RADIX-2 FFT - ALL F(H)*EXP(-ip) ARE TREATED AS -F(H)
      COMPLEX F(0:255),CX(0:255),A
      I1=1
      M2=N/2
      DO 1 I=1,NX
      I0=I1
      I2=I1-1
      I1=I1+I1
      DO 2 J=0,N-1,I1
      A=F(J+I0)
      F(J+I0)=F(J)-A
      F(J)=F(J)+A
      I4=0
      DO 3 K=J+1,J+I2
      I4=I4+M2
      A = F(K+I0)*CX(I4)
      F(K+I0)=F(K)-A
    3 F(K)=F(K)+A
    2 CONTINUE
    1 M2=M2/2
      RETURN
      END
C
      SUBROUTINE SWAP(JH,JK,JL,PH,IHORZ,IVERT,ISECT)
      INTEGER*2 JH,JK,JL,NV(3)
      NV(1) = JH
      NV(2) = JK
      NV(3) = JL
      JH = NV(ISECT)
      JK = NV(IHORZ)
      JL = NV(IVERT)
      IF(JH) 1,2,3
    2 IF(JK) 1,4,3
    4 IF(JL) 1,3,3
    1 JH=-JH
      JK=-JK
      JL=-JL
      PH=-PH
    3 RETURN
      END
C
C     OPTIONAL FFT ROUTINE FOR ECONOMIZING 90 DEGREE PHASE SHIFTS.
C     YOU CAN COMPARE THIS WITH SUBROUTINE FFT(N,F,CX,NX) TO SEE IF
C     IT RUNS ANY FASTER IN YOUR COMPUTING ENVIRONMENT.
C 
      SUBROUTINE FFT0(MPAR,F,CX,NX)
      complex f(0:255),cx(0:255),a
      N1=MPAR-1
      do 4 i=0,N1,2
      a=f(i+1)
      f(i+1)=f(i)-a
    4 f(i)=f(i)+a
      do 6 i=0,N1,4
      a=f(i+2)
      f(i+2)=f(i)-a
      f(i)=f(i)+a
      a=f(i+3)
      c=-real(a)
      d=aimag(a)
      a=cmplx(d,c)
      f(i+3)=f(i+1)-a
    6 f(i+1)=f(i+1)+a
      i1=4
      j1=1
      m2=abs(MPAR)/8
      m22=m2+m2
      do 1 level = 1,NX-2
      i0=i1
      i1=i1+i1
      j1=j1+j1
      do 2 i=0,N1,i1
      i4=0
      a=f(i+i0)
      f(i+i0)=f(i)-a
      f(i)=f(i)+a
      a=f(i+j1+i0)
      c=-real(a)
      d=aimag(a)
      a=cmplx(d,c)
      f(i+j1+i0)=f(i+j1)-a
      f(i+j1)   =f(i+j1)+a
      do 3 k=i+1,i+j1-1
      i4=i4+m2
      kk=k+i0
      a = f(kk)*cx(i4)
      f(kk)=f(k)-a
      f(k)= f(k)+a
      a = f(kk+j1)*cx(i4+m22)
      f(kk+j1)=f(k+j1)-a
      f(k+j1) =f(k+j1)+a
    3 continue
    2 continue
    1 m2=m2/2
      return
      end

